C  File rclib15.for                     30-DEC-1993
C
C  Contents:
C      SUBROUTINE CRDCV(Y,NAMES,IPASS,RPASS)
C      SUBROUTINE CHEAD(KEY,Y,NAMES,IPASS,RPASS)

      SUBROUTINE CRDCV(Y,NAMES,IPASS,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/30/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      DIMENSION IPASS(20),RPASS(13)
      CHARACTER*6 LABEL,NAMES
      DIMENSION WORK(100),NAMES(1)
      COMPLEX Y(1),SERIES(100),POINTS(40),START,END,ORDER,VECTOR,
     a COEF,SUM,DLOOP,WRKAR(6),CZERO,RATIO(3),HOVERC,SINGUL
      COMMON /PATHCM/POINTS,START,END,ORDER,VECTOR,KPTS,KPAST
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST = IPASS(5)
      INTSTP = IPASS(9)
      KENDFG = IPASS(13)
      NTERMS = IPASS(14)
      RADIUS = RPASS(1)
      H = RPASS(2)
      HNEW = RPASS(3)
      ERRLIM = RPASS(4)
      BOTTM = 1.E-35
      ERROR = 1.E29
      RERTOL = 0.01
      HTOP = ERROR
      RADLOW = ERROR
      CZERO = CMPLX(0.0,0.0)
  160 LENGTH = LENSER
      DO 166 II=1,NUMEQS
      IL = (II-1)*LENVAR
      LENY = REAL(Y(LENVAR+IL)) + 0.3
      LENGTH = MIN0(LENGTH,LENY,100)
      DO 161 K=1,LENGTH
      LENSIN = LENGTH + 1 - K
      IF(Y(LENSIN+IL) .NE. CZERO) GO TO 162
  161 CONTINUE
  162 Y(LENVAR+IL) = LENSIN + 0.3
      IF(LENSIN.GE.15) GO TO 166
      WRITE(LIST,1040) LENSIN
 1040 FORMAT(' LENSER =',I4,' is too short.')
      STOP
  166 CONTINUE
      DO 590 II=1,NUMEQS
      IL = (II-1)*LENVAR
      RDCERR = ERROR
      LENSIN = REAL(Y(LENVAR+IL))
      DO 171 K=1,LENSIN
  171 SERIES(K) = Y(K+IL)
      NLABEL = REAL(Y(LENVAR-5+IL))
      LABEL = NAMES(NLABEL)
  210 IFIRST = LENSIN - 3
      ILAST = LENSIN - 1
      HOVERC = CZERO
      RDCERR = 0.0
      ORDER = CZERO
      IF(CABS(SERIES(IFIRST)).EQ.0.0 .OR.
     + CABS(SERIES(IFIRST+1)).EQ.0.0 .OR.
     + CABS(SERIES(ILAST)).EQ.0.0) GO TO 410
      RATIO(3) = SERIES(ILAST+1)/SERIES(ILAST)*(ILAST)
      RATIO(2) = SERIES(ILAST)/SERIES(ILAST-1)*(ILAST-1)
      RATIO(1) = SERIES(ILAST-1)/SERIES(ILAST-2)*(ILAST-2)
      HOVERC = RATIO(3) - RATIO(2)
      TEMP = CABS(HOVERC)
      IF(TEMP.GT.30.0 .OR. TEMP.LT.0.15) GO TO 410
      RDCERR = CABS(RATIO(3)-2.0*RATIO(2)+RATIO(1))/(2.0*TEMP+ERRLIM)
      ORDER = RATIO(3)/HOVERC - (ILAST-1)
      SINGUL = START + H/HOVERC
      RCREAL = REAL(SINGUL)
      RCIMAG = AIMAG(SINGUL)
      RADIN = H/CABS(HOVERC)
      IF(RDCERR.GE.RERTOL) GO TO 410
      IF(MPRINT.LT.6) GO TO 500
      WRITE(LIST,1240)INTSTP,LABEL,RADIN,RDCERR,START,RCREAL,RCIMAG,
     a ORDER
 1240 FORMAT(/' Step',I4,' for ',A6,' by 3TA, Rc =',1PE9.2,
     a ' with ERROR',E10.2/'   at',2X,'real',6X,'imag',10X,'Rcreal',
     b 6X,'Rcimag',11X,'ORDER'/1X,1P2E12.4,2X,2E12.4,3X,2E10.3)
      GO TO 500
  410 DO 415 K=1,LENSIN
      TMP = SERIES(K)
      IF(TMP.NE. 0.0) GO TO 416
  415 CONTINUE
  416 IF(K.EQ.1) GO TO 419
      DO 417 KK=1,K
  417 SERIES(KK) = TMP
  419 DO 420 K=1,LENSIN
      WORK(K) = ALOG(CABS(SERIES(K))+BOTTM)*1000.0
  420 CONTINUE
      TEMP1 = (WORK(LENSIN) - WORK(1))/(LENSIN-1)
      TEMP4 = WORK(1) - TEMP1
      KD = (LENSIN-1)/2 - 1
      KB = LENSIN
      KA = 1
      DO 430 L=1,2
      DO 428 K=1,KD
      TEMP8 = WORK(KB)
      I = 1 + K
      TEMP7 = WORK(I)
      IF(TEMP7.LE.(TEMP1*I+TEMP4)) GO TO 426
      KA = I
      TEMP1 = (TEMP8 - TEMP7)/(KB-KA)
      TEMP4 = TEMP7 - TEMP1*KA
  426 TEMP7 = WORK(KA)
      I = LENSIN - K
      TEMP8 = WORK(I)
      IF(TEMP8.LE.(TEMP1*I+TEMP4)) GO TO 428
      KB = I
      TEMP1 = (TEMP8 - TEMP7)/(KB-KA)
      TEMP4 = TEMP7 - TEMP1*KA
  428 CONTINUE
  430 CONTINUE
      KS = LENSIN/2 + 2
      TEMP2 = (WORK(LENSIN) - WORK(KS))/(LENSIN-KS)
      TEMP4 = WORK(KS) - TEMP2*KS
      KD = (LENSIN-KS)/2 - 1
      KB = LENSIN
      KA = KS
      DO 440 L=1,2
      DO 438 K=1,KD
      TEMP8 = WORK(KB)
      I = KS + K
      TEMP7 = WORK(I)
      IF(TEMP7.LE.(TEMP2*I+TEMP4)) GO TO 436
      KA = I
      TEMP2 = (TEMP8 - TEMP7)/(KB-KA)
      TEMP4 = TEMP7 - TEMP2*KA
  436 TEMP7 = WORK(KA)
      I = LENSIN - K
      TEMP8 = WORK(I)
      IF(TEMP8.LE.(TEMP2*I+TEMP4)) GO TO 438
      KB = I
      TEMP2 = (TEMP8 - TEMP7)/(KB-KA)
      TEMP4 = TEMP7 - TEMP2*KA
  438 CONTINUE
  440 CONTINUE
      TEMP5 = AMAX1(TEMP1,TEMP2)
      HOVERC = CMPLX(EXP(TEMP5/1000.0)*1.1,0.0)
      RADIN = H/CABS(HOVERC)
      RDCERR = 1.0
      IF(MPRINT.LT.6) GO TO 500
      WRITE(LIST,1460) INTSTP,LABEL,START,RADIN
 1460 FORMAT(/' Step',I4,' for ',A6,' estimated by TOP-LINE analysis'/
     A '   at',2X,'real',6X,'imag',11X,'Rc'/1X,1P2E12.4,2X,E12.4)
  500 HNEWIN = RADIN*ERRLIM**(1.0/(LENSIN-1))
      HTOP = AMIN1(HNEWIN,HTOP)
      IF(INTSTP.GT.1) HTOP = AMIN1(HTOP,2.0*ABS(HNEW))
      IF(RADLOW.LE.RADIN) GO TO 510
      RADLOW = RADIN
      IPASS(15) = II
  510 NOPT = 0
      IF(RDCERR.GT.(5.E-3)) GO TO 580
      WRITE(LIST,1901)LABEL,RCREAL,RCIMAG,RDCERR,ORDER
 1901 FORMAT(' for ',A6,' Rc,err,ord',1P2E12.4,E10.1,1X,2E11.3)
      NOPT = 1
  580 IF(MPRINT.LT.9) GO TO 590
      ADJT = 1.D0/HOVERC
      IF(MPRINT.EQ.10) ADJT = 1.0
      HP = H*ADJT
      WRITE(LIST,1523) LABEL,START,HP
 1523 FORMAT(/' series for ',A6,', at',1P2E12.4,', Rc or h =',E10.2)
      PROD = 1.0
      DO 530 J=1,LENSER
      WORK(J) = PROD*CABS(Y(J+IL))
  530 PROD = PROD*ADJT
      LP = LENSER/5
      NP = LENSER - 5*LP
      MP = LP + 1
      M = LENSER - LP*(4 - NP)
      DO 565 I = 1,LP
      IF(M.LT.LENSER) GO TO 563
      IF(NP.EQ.4) LP = MP
      WRITE(LIST,1569)(K,WORK(K),K=I,LENSER,LP)
      GO TO 565
  563 IP = I + M
      WRITE(LIST,1569)(K,WORK(K),K=I,M,MP),(L,WORK(L),L=IP,LENSER,LP)
  565 CONTINUE
      IF(NP.EQ.0) GO TO 590
      WRITE(LIST,1569)(K,WORK(K),K=MP,M,MP)
 1569 FORMAT(1X,I4,1PE10.3,I4,E10.3,I4,E10.3,I4,E10.3,I4,E10.3)
  590 CONTINUE
      HNEW = HTOP
      RPASS(3) = HTOP
      IF(INTSTP.EQ.1) GO TO 591
      RADIUS = 2.*RADIUS
      RPASS(1) = RADIUS
      IF(RADIUS.LT.RADLOW) GO TO 592
  591 RPASS(1) = RADLOW
  592 IF(MPRINT.GT.4 .OR. NOPT.EQ.0) GO TO 20004
      WRITE(LIST,21009) START,INTSTP
21009 FORMAT('  Above is at',1P2E12.5,' step no.',I4)
20004 KENDFG = 1
      IPASS(13) = 1
      ENDSTA = CABS(POINTS(KPAST+1)-START)
      IF(HNEW*HNEW .LT. ENDSTA*ENDSTA) GO TO 10300
      HNEW = ENDSTA*0.99999
      RPASS(3) = HNEW
      KPAST = KPAST + 1
      KENDFG = 4
      IF(KPAST.EQ.KPTS) KENDFG = 2
      IPASS(13) = KENDFG
10300 IF(KENDFG.NE.2) GO TO 20016
      COEF = (END - START)/H
      SUM = END
      GO TO 20020
20016 COEF = HNEW*VECTOR/H
      SUM = START + HNEW*VECTOR
20020 IF(KENDFG.EQ.1 .AND. MPRINT.LT.5) GO TO 20025
      WRITE(LIST,21010) INTSTP,NAMES(1),SUM
21010 FORMAT(/5X,'Step number',I6,' at',A6,' = ',1P2E12.4)
20025 DO 29999 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = REAL(Y(LENVAR-5+IL))
      DDUMY = 1.0
      DO 20040 I=1,NTERMS
      IBOT = I + 1
      DLOOP = 1.0
      SUM = Y(I+IL)*DDUMY
      DO 20030 J=IBOT,LENSER
      DLOOP = DLOOP*COEF*(J-1)/(J-IBOT+1)
      IF(CABS(DLOOP).LT.BOTTM) GO TO 20035
      SUM = SUM + DLOOP*Y(J+IL)*DDUMY
20030 CONTINUE
20035 WRKAR(I) = SUM
20040 DDUMY = DDUMY*(I)/H
      IF(KENDFG.EQ.1 .AND. MPRINT.LT.5) GO TO 20050
      WRITE(LIST,21941) NAMES(NLABEL),(WRKAR(I),I=1,NTERMS)
21941 FORMAT(1X,A6,(1X,1P4E13.5))
20050 DO 20060 I=1,NTERMS
      LMI = LENSER+I
      Y(LMI+IL) = Y(I+IL)
20060 Y(I+IL) = WRKAR(I)
29999 CONTINUE
      IF(KENDFG.EQ.4) KENDFG = 1
      IPASS(13) = KENDFG
C********
C end CRDCV
C********
      RETURN
      END
      SUBROUTINE CHEAD(KEY,Y,NAMES,IPASS,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/30/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      DIMENSION IPASS(20),RPASS(13)
      CHARACTER*6 NAMES(1)
      COMPLEX Y(1)
      SAVE NOPRT,TESTB,TESTT
      DATA NOPRT/1/
C IPASS(18) = KOUNT
      NUMEQS = IPASS(1)
      LENSER = IPASS(2)
      LENVAR = IPASS(3)
      MPRINT = IPASS(4)
      LIST = IPASS(5)
      INTSTP = IPASS(9)
      GO TO (1000,2000,3000,5000,5000), KEY
 1000 IF(MPRINT.EQ.0) RETURN
      WRITE(LIST,11) NAMES(1),RPASS(8)
   11 FORMAT(/5X,'Step number     0 at',A6,' =',1P2E12.5)
      DO 1100 II=1,NUMEQS
      IL = (II-1)*LENVAR
      NLABEL = REAL(Y(LENVAR-5+IL))
      LORDER = 10.0*(REAL(Y(LENVAR-5+IL)) - NLABEL)
      IPRINT = MAX0(1,LORDER)
      WRITE(LIST,12) NAMES(NLABEL),(Y(I+IL),I=1,IPRINT)
   12 FORMAT(1X,A6,(1X,1P4E13.5))
 1100 CONTINUE
      RETURN
 2000 IL = (IPASS(15)-1)*LENVAR
      KINDX = REAL(Y(LENVAR+IL)) + 0.1
      TMP = CABS(Y(KINDX+IL))
      IF(INTSTP.GT.1 .AND. TMP.LT.1.0) GO TO 2023
      IF(TMP.LE.1.E-35) GO TO 2023
      IF(TMP.LT.TESTT .AND. TMP.GT.TESTB) GO TO 2023
      IPASS(18) = IPASS(18) + 1
      IF(IPASS(18).LT.5) GO TO 2022
      WRITE(LIST,16)
   16 FORMAT(/5X,'The trial H adjustment needs some help.')
      STOP
 2022 HNEW = RPASS(2)*TMP**(0.6/(1-KINDX))
      RPASS(3) = HNEW
      IF(MPRINT.GT.3) WRITE(LIST,13) HNEW,KINDX
   13 FORMAT(5X,'Trial H adjusted to ',1PE13.5,' at term #',I4)
      IPASS(7) = 0
      RETURN
 2023 IPASS(7) = 1
      IPASS(18) = 0
      RETURN
 3000 WRITE(LIST,14) INTSTP
   14 FORMAT(/5X,'The solution stopped normally after',I4,
     a ' steps as set by NSTEPS.')
      RETURN
 5000 IF(NOPRT .EQ. 0) GO TO 5010
      NOPRT = 0
      WRITE(LIST,10)IPASS(13),IPASS(7)
   10 FORMAT(' ATOMFT  ver. ',I1,'.',I1,'1, copyright (C) 1979-93, Y. F.
     A Chang; Solution results.'/' ******')
      IPASS(18) = 0
      KXPMAX = IPASS(11) - (IPASS(11)/10000)*10000
      KEXP = KXPMAX*8/10
      TESTB = 0.1**(KEXP)
      TESTT = 10.0**(KEXP)
 5010 DO 5100 II=1,NUMEQS
      IL = (II-1)*LENVAR
      DO 5100 K=1,LENSER
      Y(K+IL) = CMPLX(0.0,0.0)
 5100 CONTINUE
      RETURN
C********
C end CHEAD
C********
      END
