C  File rclib6.for                     30-DEC-1993

      SUBROUTINE SRTPLY(NUMBER,POLY,ROOTR,ROOTI,LIST,RPASS)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (7/23/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C  This is the version for real polynomials, only.
C  This is not RTPOLY.  It is only a small non-proper subset.
C------
      DIMENSION POLY(1),ROOTR(1),ROOTI(1),RPASS(20)
      DOUBLE PRECISION POLYIN(30),DFTR(30),DFTI(30),TMPR(30),TMPI(30),
     A OVFR(10),OVFI(10),RR(10),RI(10),ZR,ZI,PR,PI,CR1,CI1,CR2,CI2,
     B ZZABS,DMAX,COEF,DDR,DDI,ERCP,SIZE,TINY,SMALL,S1,S2,S3,SQD,
     C SQF,SQZ,ZMIN

C..Initialize constants.
      DMAX = RPASS(14)
      SIZE = DSQRT(DMAX)
      TINY = 1.D0/DMAX
      SMALL = 1.D0/SIZE
      DO 50 J=1,NUMBER
      JR = NUMBER + 1 - J
      IF(POLY(JR) .NE. 0.0) GO TO 51
   50 CONTINUE
   51 KOUNT = JR
      NTOP = 0
      NUM = KOUNT
      RR(1) = 1.D0
      RI(1) = 0.D0
      DO 100 J=1,KOUNT
  100 POLYIN(J) = POLY(J)
C..Normalize POLYIN and initialize the DFT.
      DDR = 1.D0/POLYIN(NUM)
      DO 101 J=1,KOUNT
      POLYIN(J) = POLYIN(J)*DDR
      DFTI(J) = 0.D0
  101 DFTR(J) = POLYIN(J)
C..Make an initial wild guess.
 2000 ZMIN = DMAX
      DDR = DMAX1(DABS(DFTR(1)),DABS(DFTI(1)))
      DO 3000 I=2,NUM
      IF(DFTR(I).EQ.0.D0 .AND. DFTI(I).EQ.0.D0) GO TO 3000
      DDI = DMAX1(DABS(DFTR(I)),DABS(DFTI(I)))
      S1 = (DDR)**(1.D0/(I-1))
      S2 = (DDI)**(1.D0/(I-1))
      IF(S1/S2 .LT. ZMIN) ZMIN = S1/S2
 3000 CONTINUE
      ZR = ZMIN
      ZI = 1.D-2*ZMIN
      JUMP = 0
 5000 MSECND = 0
      DO 5600 MFIRST=1,200
      DO 5001 I=1,NUM
      TMPR(I) = DFTR(I)
 5001 TMPI(I) = DFTI(I)
      SQZ = SIZE/DSQRT(DMAX1(DABS(ZR),DABS(ZI)))
      DO 5150 J=1,10
      CR1 = 1.D0/J
      OVFR(J) = TMPR(NUM)
      OVFI(J) = TMPI(NUM)
      TMPR(NUM) = TMPR(NUM)*(NUM-J)*CR1
      TMPI(NUM) = TMPI(NUM)*(NUM-J)*CR1
      IBOT = J + 1
      DO 5120 I=IBOT,NUM
      JM = NUM + J - I
      SQF = DSQRT(DMAX1(DABS(OVFR(J)),DABS(OVFI(J))))
      IF(SQF .GT. SQZ) GO TO 5207
      COEF = TMPR(JM) + OVFR(J)*ZR - OVFI(J)*ZI
      OVFI(J) = TMPI(JM) + OVFR(J)*ZI + OVFI(J)*ZR
      OVFR(J) = COEF
      TMPR(JM) = TMPR(JM)*(NUM-I)*CR1
 5120 TMPI(JM) = TMPI(JM)*(NUM-I)*CR1
      IF(J .GT. 1) GO TO 5130
      IF(OVFI(1) .EQ. 0.D0) THEN
        DDR = 1.D0/OVFR(1)
      ELSE IF(DABS(OVFR(1)/OVFI(1)) .LT. SMALL) THEN
        DDR = 0.D0
      ELSE
        DDR = 1.D0/(OVFR(1) + (OVFI(1)/OVFR(1))*OVFI(1))
      ENDIF
      IF(OVFR(1) .EQ. 0.D0) THEN
        DDR = 1.D0/OVFI(1)
      ELSE IF(DABS(OVFI(1)/OVFR(1)) .LT. SMALL) THEN
        DDI = 0.D0
      ELSE
        DDI = 1.D0/((OVFR(1)/OVFI(1))*OVFR(1) + OVFI(1))
      ENDIF
      SQD = SIZE/DSQRT(DMAX1(DABS(DDR),DABS(DDI)))
      GO TO 5150
 5130 SQF = DSQRT(DMAX1(DABS(OVFR(J)),DABS(OVFI(J))))
      IF(SQF .GT. SQD) GO TO 5207
      COEF = OVFR(J)*DDR + OVFI(J)*DDI
      OVFI(J) = -OVFR(J)*DDI + OVFI(J)*DDR
      OVFR(J) = COEF
      IF(DABS(OVFR(J)).LE.TINY .AND. DABS(OVFI(J)).LE.TINY) GO TO 5207
      IF(J .EQ. NUM) GO TO 5208
 5150 CONTINUE
      J = 11
 5207 J = J - 1
      IF(J .LT. 2) GO TO 2000
 5208 DO 5312 NRT=2,10
      RR(NRT) = 0.D0
      RI(NRT) = 0.D0
      KTOP = MIN0(NRT,J)
      DO 5311 K=2,KTOP
      JM = NRT + 1 - K
      SQD = DSQRT(DMAX1(DABS(RR(JM)),DABS(RI(JM))))
      SQF = DSQRT(DMAX1(DABS(OVFR(K)),DABS(OVFI(K))))
      IF(SQF*SQD .GT. SIZE) GO TO 5313
      COEF = RR(NRT) - OVFR(K)*RR(JM) + OVFI(K)*RI(JM)
      RI(NRT) = RI(NRT) - OVFR(K)*RI(JM) - OVFI(K)*RR(JM)
 5311 RR(NRT) = COEF
      IF(DABS(RR(NRT)).LE.TINY .AND. DABS(RI(NRT)).LE.TINY) GO TO 5313
 5312 CONTINUE
      NRT = 11
 5313 NRT = NRT - 1
      IF(NRT .LT. 3) GO TO 6000
      COEF = 1.D0/(RR(NRT) + (RI(NRT)/RR(NRT))*RI(NRT))
      DDR = 1.D0/(RR(NRT-1) + (RI(NRT-1)/RR(NRT-1))*RI(NRT-1))
      PR = (RR(NRT-1) + (RI(NRT-1)/RR(NRT))*RI(NRT))*COEF
      PI = (RI(NRT-1) - (RR(NRT-1)/RR(NRT))*RI(NRT))*COEF
      CR1 = (RR(NRT-2) + (RI(NRT-2)/RR(NRT-1))*RI(NRT-1))*DDR
      CI1 = (RI(NRT-2) - (RR(NRT-2)/RR(NRT-1))*RI(NRT-1))*DDR
      CR2 = PR - CR1
      CI2 = PI - CI1
      S1 = DSQRT(PR*PR + PI*PI)
      S2 = DSQRT(CR2*CR2 + CI2*CI2)
      S3 = DSQRT(CR1*CR1 + CI1*CI1)
      ERCP = DMAX1(S2/S1,S2/S3)
      IF(JUMP.EQ.0 .OR. ERCP.LT.5.D-1) GO TO 5420
      DDR = DMAX1(DABS(PR),DABS(PI))
      SQZ = 2.1D0*DMAX1(DABS(ZR),DABS(ZI))
      IF(DDR .GT. SQZ) GO TO 2000
 5420 ZR = ZR + PR
      ZI = ZI + PI
      IF(ERCP .LT. 1.D-9) GO TO 6000

 5600 CONTINUE
 5613 WRITE(LIST,13)NTOP,MFIRST,MSECND
   13 FORMAT(' SRTPLY failed after ',I4,' zeros, w/loops',2I3/
     A ' Please send this problem to Y. F. Chang.')
      STOP
 6000 DO 6100 MSECND=1,20
      DO 6004 I=1,KOUNT
      TMPR(I) = POLYIN(I)
 6004 TMPI(I) = 0.D0
      ITOP = KOUNT - 1
      CR1 = TMPR(KOUNT)
      CI1 = TMPI(KOUNT)
      CR2 = TMPR(KOUNT)*(KOUNT-1)
      CI2 = TMPI(KOUNT)*(KOUNT-1)
      DO 6008 I=2,ITOP
      JJ = KOUNT + 1 - I
      COEF = TMPR(JJ) + CR1*ZR - CI1*ZI
      CI1 = TMPI(JJ) + CR1*ZI + CI1*ZR
      CR1 = COEF
      COEF = TMPR(JJ)*(JJ-1) + CR2*ZR - CI2*ZI
      CI2 = TMPI(JJ)*(JJ-1) + CR2*ZI + CI2*ZR
 6008 CR2 = COEF
      COEF = TMPR(1) + CR1*ZR - CI1*ZI
      CI1 = TMPI(1) + CR1*ZI + CI1*ZR
      CR1 = COEF
      ZZABS = 1.D0/(CR2 + (CI2/CR2)*CI2)
      PR = - (CR1 + (CI1/CR2)*CI2)*ZZABS
      PI = ((CR1/CR2)*CI2 - CI1)*ZZABS
      ZR = ZR + PR
      ZI = ZI + PI
      DDI = DMAX1(DABS(PR),DABS(PI))/DMAX1(DABS(ZR),DABS(ZI))
      IF(DDI .LT. 1.D-9) GO TO 7000
 6100 CONTINUE
      GO TO 5613
 7000 IF(ZI.GT.1.D-9 .OR. ZI.LT.(-1.D-9)) GO TO 7010
      IF(DABS(ZI/(ZR+1.D-9)).LT.1.D-9) ZI = 0.D0
 7010 NTOP = NTOP + 1
      ROOTR(NTOP) = ZR
      ROOTI(NTOP) = ZI
      IF(NTOP.GE.(KOUNT-1)) RETURN
      TMPR(NUM-1) = DFTR(NUM-1)
      TMPI(NUM-1) = DFTI(NUM-1)
      DFTR(NUM-1) = DFTR(NUM)
      DFTI(NUM-1) = DFTI(NUM)
      NUM = NUM - 1
      DO 7410 J=2,NUM
      JJ = NUM + 1 - J
      TMPR(JJ) = DFTR(JJ)
      TMPI(JJ) = DFTI(JJ)
      COEF = TMPR(JJ+1) + DFTR(JJ+1)*ZR - DFTI(JJ+1)*ZI
      DFTI(JJ) = TMPI(JJ+1) + DFTR(JJ+1)*ZI + DFTI(JJ+1)*ZR
 7410 DFTR(JJ) = COEF
 7500 CONTINUE
      IF(NUM.GT.2) GO TO 8100
      DDR = 1.D0/(DFTR(2) + (DFTI(2)/DFTR(2))*DFTI(2))
      ZR = - (DFTR(1) + (DFTI(1)/DFTR(2))*DFTI(2))*DDR
      ZI = - (DFTI(1) - (DFTR(1)/DFTR(2))*DFTI(2))*DDR
      GO TO 6000
 8100 COEF = - ZR*0.6983D0 - ZI*0.6D0
      ZI = ZR*0.6D0 - ZI*0.6983D0
      ZR = COEF
      JUMP = 1
      GO TO 5000
C******
C end SRTPLY
C******
      END
