REM echo off
set ATOMFT=E:\Atom3_11\Bin\atomft.exe
set RDCVLIB=E:\Atom3_11\Lib\rdcvlib.lib
if exist %1.ato goto TRANSL
@echo Command file to run ATOMFT.  Usage:
@echo RUNATOM filename [A or C or R]
@echo     filename.ATO    contains the input ODE.
@echo     Options:  A     Only run ATOMFT.  Do not compile.
@echo               C     Run ATOMFT, compile, and link.
@echo               R     Run ATOMFT, compile, link, and run.
@echo For Microsoft Fortran version 5.1
goto DONE
:TRANSL
@echo Running ATOMFT translator.
copy %1.ato odeinp. > nul
if exist atspgm. del atspgm.
%ATOMFT%
if "%2" == "a" goto DONE
if "%2" == "A" goto DONE
if exist atspgm. goto COMPIL
@echo Error occurred in translation.  Processing stops.
goto DONE
:COMPIL
@echo Compiling object program.
copy atspgm. %1.for > nul
fl /FPi87 /Od /nologo /c %1.for
fl /FPi87 /nologo %1.obj,,,%RDCVLIB%;
if "%2" == "c" goto DONE
if "%2" == "C" goto DONE
if exist %1.obj goto RUNOBJ
echo Error occurred in compilation.  Processing stops.
goto DONE
:RUNOBJ
echo Running object program.
%1
:DONE
