C File atomft2.for                     30-DEC-1993
C
C ATOMFT Compiler, version 3.11, Copyright (C) 1979-93, Y. F. Chang
C  Version 3.11 completed (6/21/93)
C---------------------------------------------------------------
C
C MSF:
C These two lines are for Microsoft FORTRAN only.
C$LARGE
C$STORAGE:2
C EQSORT SUBROUTINE
C ------ ----------
C This subroutine sorts the differential equations, and organizes the
C  constants and variables.
C***************
      SUBROUTINE EQSORT(MEQLIM,DCONS,MINDV,MTRPL,INOUT,MND,MVAR,MEQU)
C***************

C MSF:
C     Microsoft Fortran version 5.1 requires the [NEAR] attribute:
c      DIMENSION DCONS(1),MTRPL(1),INOUT(3),MVAR(1),MEQU(1),MINDV(1),
c     A MND(1),KTYPE[NEAR](2)
      DIMENSION DCONS(1),MTRPL(1),INOUT(3),MVAR(1),MEQU(1),MINDV(1),
     A MND(1),KTYPE(2)

      DOUBLE PRECISION DCONS
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
     A /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
     B /TYPODR/LNL(48),LNL1(3,3,4),KORDJ(48),KRES(48),
     C KRES1(3,3,4),KRES2(3),KITR1(3,3,4),KITR2(3,3)
     E /FLAGS/MRUN,MVCNT
      COMMON/ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      EQUIVALENCE (KTYPE(1),KT1),(KTYPE(2),KT2)
      DATA KEQUP1,KEQUP2,KORDCM,KTYPCM,KORDNX,KORDMS/1,1,0,0,0,0/
      NVAR3 = NVARS*2
      NVAR4 = NVARS*3
      NOP3 = NOPS*2
      NOP4 = NOPS*3
C--------
C Initializations for number of triplets and DIFF storage array
C--------
      MXSIZ = MAXSIZ/10
      INLIM = MEQU(MEQLIM)
      MINDV(1) = 0
 1701 KORDCH = 0
      KTYPCH = 0
      KECOND = MEQLIM
      KEQUS = 0
      KTRPS = 1
C--------
C DO 1734 loops once for each triplet.
C--------
      DO 1734 MTRPLP=1,INLIM
      MTEMP1 = MTRPL(MTRPLP)
      IF(KORDCM.NE.0) GO TO 1717
C--------
C This is the equation ordering section.  If this equation is not to be
C  checked(KORDNX=1), or an undefined variable has been found(KORDMS=1),
C  then only the = triplet is checked.  Otherwise, = and DIFF triplets
C  are processed separately from other operators.
C--------
      JUMP = KORDJ(MTEMP1)
      IF(KORDNX.EQ.1 .OR. KORDMS.EQ.1) JUMP = JUMP + 3
      GO TO (1702,1708,1710,1717,1717,1710), JUMP
C--------
C This is the ordering section for triplets other than = and DIFF.
C--------
 1702 MTEMP2 = LOPLIM(MTEMP1) + 1
      DO 1707 INDEX=2,MTEMP2
      MTP = MTRPLP + NOPS*(INDEX - 1)
      MTEMP3 = MTRPL(MTP)
      IF((MTEMP3.GE.KTRPS.AND.MTEMP3.LT.MAXSIZ) .OR.MTEMP3.GT.2*MAXSIZ)
     A GO TO 1707
      IF(MTEMP3.GT.MAXSIZ) GO TO 1706
      IF(KEQUS.EQ.0) GO TO 1704
      DO 1703 I=1,KEQUS
      N = MEQLIM + I
      IF(MTEMP3.GT.MEQU(N).AND.MTEMP3.LT.MEQU(N+NVARS)) GO TO 1705
 1703 CONTINUE
 1704 KORDMS = 1
      GO TO 1707
 1705 M = N - MEQLIM
      IF(MEQU(M).LT.0) GO TO 1707
      GO TO 1704
 1706 MTEMP3 = MTEMP3 - MAXSIZ
      IF(MEQU(MTEMP3+NVAR3) .LE. 0) KORDMS = 1
 1707 CONTINUE
      GO TO 1717
C--------
C This is the ordering section for DIFF operators.  If not enough terms
C  of the dependent and independent variables have been defined, or the
C  independent/dependent variable combination has not been defined then
C  the undefined variable flag(KORDMS) is set to 1.
C--------
 1708 IF(MTRPLP-1.EQ.0) GO TO 1717
      IF(MTRPL(MTRPLP-1) .EQ. 44) GO TO 1717
      MTEMP4 = MTRPL(MTRPLP+NOP3)/MXSIZ
      MTEMP3 = MTRPL(MTRPLP+NOP3) - MXSIZ*MTEMP4
      MTEMP2 = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MEQU(MTEMP2+NVAR3).LE.MTEMP4 .OR.
     A   MEQU(MTEMP3+NVAR3).LE.1) KORDMS = 1
      INDEX = 0
 1709 INDEX = INDEX + 1
      IF((MINDV(INDEX).EQ.MTEMP2 .OR. MINDV(INDEX).EQ.MTEMP3)
     A  .AND. MINDV(INDEX+NEQUS).EQ.MTEMP3) GO TO 1717
      IF(MINDV(INDEX) .NE. 0) GO TO 1709
      KORDMS = 1
      GO TO 1717
C--------
C This is the ordering section for = triplets.  Variables on the LHS of
C  the = sign are defined, including independent and dependent variables
C  in DIFF functions.  Each time a change is made, the flag (KORDCH) is
C  set to 1.
C--------
 1710 KECOND = KECOND + 1
      KEQUS = KEQUS + 1
      MEQU(KECOND) = KTRPS
      KTRPS = MTRPLP
      MEQU(KECOND+NVARS) = KTRPS
      IF(MTRPL(MTRPLP+NOPS) .GT. MAXSIZ) GO TO 1713
      INDEX = MTRPL(MTRPLP+NOPS)
      MTEMP4 = MTRPL(INDEX+NOP3)/MXSIZ
      MTEMP3 = MTRPL(INDEX+NOP3) - MXSIZ*MTEMP4
      MTEMP2 = MTRPL(INDEX+NOPS) - MAXSIZ
      INDEX = 0
      IF(MEQU(MTEMP3+NVAR3) .GE. 2) GO TO 1711
      MEQU(MTEMP3+NVAR3) = 2
      KORDCH = 1
 1711 IF(MEQU(MTEMP2+NVAR3) .GE. MTEMP4) GO TO 1712
      MEQU(MTEMP2+NVAR3) = MTEMP4
      KORDCH = 1
C--------
C Check the indep/dep var combination for previous definition
C--------
 1712 INDEX = INDEX + 1
      IF(MINDV(INDEX).EQ.MTEMP2 .AND. MINDV(INDEX+NEQUS).EQ.MTEMP3)
     A   GO TO 1713
      IF(MINDV(INDEX) .NE. 0) GO TO 1712
      MINDV(INDEX) = MTEMP2
      MINDV(INDEX+NEQUS) = MTEMP3
      MINDV(INDEX+1) = 0
      KORDCH = 1
C--------
C Check single variable on RHS of =.
C--------
 1713 IF(MTRPL(MTRPLP+NOP3)/MAXSIZ.NE.1 .OR. MTRPL(MTRPLP).EQ.14)
     A GO TO 1714
      MTEMP2 = MTRPL(MTRPLP+NOP3) - MAXSIZ
      IF(MEQU(MTEMP2+NVAR3) .LT. 1) KORDMS = 1
C--------
C If no undefined variables were detected and this equation was not to
C  be skipped (KORDNX),then the equation is next in the ordering.
C--------
 1714 IF(KORDMS.EQ.1 .OR. KORDNX.EQ.1) GO TO 1716
      MEQU(KEQUP2+NVARS) =  MEQU(KEQUP1)
      MEQU(KEQUP1) = - MEQU(KEQUP1)
      IF(KDUMP.GT.1) CALL ERRMSG(28,KEQUP1)
      IF(MTRPL(MTRPLP+NOPS) .GT. MAXSIZ) GO TO 1715
      MEQU(MTEMP2+NVAR3) = MTEMP4 + 1
      MVAR(MTEMP2+NVAR4) = 4
 1715 KEQUP2 = KEQUP2 + 1
      KORDCH = 1
      MTEMP2 = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MTEMP2 .LT. 0) GO TO 1716
      MVAR(MTEMP2+NVAR4) = 4
      IF(MEQU(MTEMP2+NVAR3) .LT. 1) MEQU(MTEMP2+NVAR3) = 1
C--------
C End of ordering section.  KEQUP1 is pointed at the next input EQU and
C  KORDNX is set to 1 if that equation has already been ordered.
C--------
 1716 KORDMS = 0
      KORDNX = 0
      KEQUP1 = KEQUP1 + 1
      IF(MTRPLP .EQ. INLIM) KEQUP1 = 1
      IF(MEQU(KEQUP1) .LT. 0) KORDNX = 1
C--------
C This is the beginning of the type section.  This section consists of
C  two basic parts.  The first part determines the types of the operands
C  of a triplet and the second part then determines the type of the
C  result of the operation in that triplet.  The types are then stored
C  back into the 4th column of the triplet array.
C--------
 1717 IF(KTYPCM .NE. 0) GO TO 1734
      MTEMP4 = LOPLIM(MTEMP1)
      KTYPE(2) = 0
      DO 1722 MTEMP2=1,MTEMP4
      MTP = MTRPLP + NOPS*MTEMP2
      MTEMP3 = MTRPL(MTP)
      JUMP = MTEMP3/MAXSIZ + 1
      GO TO (1718,1719,1720,1720), JUMP
 1718 KTYPE(MTEMP2) = MTRPL(MTEMP3+NOP4)/16
      GO TO 1722
 1719 MTEMP3 = MTEMP3 - MAXSIZ
      IF(MTRPL(MTRPLP).EQ.14 .AND. MTEMP2.EQ.2)
     A MTEMP3 = MTEMP3 - (MTEMP3/MXSIZ)*MXSIZ
      GO TO 1721
 1720 KTYPE(MTEMP2) = 1
      IF(MTEMP1 .NE. 31) GO TO 1722
      MTEMP3 = MTEMP3 - (JUMP-1)*MAXSIZ
 1721 KTYPE(MTEMP2) = MVAR(MTEMP3+NVAR3)
 1722 CONTINUE
C--------
C This section determines the type of the result.  The type of the
C  result is stored in KREST and the number of terms which must be
C  computed before the recurrence relation for that operation will
C  be valid is stored in MTEMP2.
C--------
      MTEMP2 = 1
      JUMP = KRES(MTEMP1)
      GO TO (1724,1724,1724,1724,1725,1725,1725,1726,1727,1728), JUMP
 1724 MT1 = KT1
      MT2 = KT2
      KREST = KRES1(MT1,MT2,JUMP)
      MTEMP2 = KITR1(MT1,MT2,JUMP)
      GO TO 1731
 1725 MTEMP3 = JUMP - 4
      MT1 = KT1
      KREST  = KRES2(MT1)
      MTEMP2 = KITR2(MT1,MTEMP3)
      GO TO 1731
C--------
C DIFF triplet
C--------
 1726 KREST = KT1
      MTEMP3 = (MTRPL(MTRPLP+NOP3) - MAXSIZ)/MXSIZ
      IF(LOOPNX .LT. MTEMP3) LOOPNX = MTEMP3
      IF(LOOPNX.EQ.9) LOOPNX = 0
      GO TO 1731
C--------
C Functions
C--------
 1727 KREST = KT1
      MTEMP2 = KITR2(KREST,2)
      GO TO 1731
C--------
C Types for = triplet.
C--------
 1728 KREST = KT1
      MTEMP3 = MTRPL(MTRPLP+NOPS)
      IF(MTEMP3 .LT. MAXSIZ) GO TO 1729
      MTEMP3 = MTEMP3 - MAXSIZ
      IF(MVAR(MTEMP3+NVAR3) .GE. KT2) GO TO 1731
      MVAR(MTEMP3+NVAR3) = KT2
      KT1 = KT2
      KTYPCH = 1
      GO TO 1731
C--------
C DIFF on LHS of =
C--------
 1729 MTEMP4 = MTRPL(MTEMP3+NOPS) - MAXSIZ
      IF(MVAR(MTEMP4+NVAR3) .GE. 3) GO TO 1730
      MVAR(MTEMP4+NVAR3) = 3
      KTYPCH = 1
 1730 MTEMP4 = MTRPL(MTEMP3+NOP3)/MXSIZ
      MTEMP3 = MTRPL(MTEMP3+NOP3) - MTEMP4*MXSIZ
      IF(MVAR(MTEMP3+NVAR3) .GT. 1) GO TO 1731
      MVAR(MTEMP3+NVAR3) = 2
      KTYPCH = 1
 1731 MTRPL(MTRPLP+NOP4) = KREST*16 + KT1*4 + KT2
      IF(MTRPL(MTRPLP).NE.13) GO TO 1733
      MTEMP4 = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MTEMP4.LT.MAXSIZ) GO TO 1732
      MVAR(MTEMP3+NVAR3) = 1
      MTRPL(MTRPLP+NOP4) = 21
      GO TO 1733
 1732 MTEMP4 = MVAR(MTEMP4+NVAR3)
      IF(MTEMP4.LT.2) MVAR(MTEMP3+NVAR3) = 1
      IF(MTEMP4.GT.1) MTRPL(MTRPLP+NOP4) = 3*21
 1733 IF(LITNUM .LT. MTEMP2) LITNUM = MTEMP2
 1734 CONTINUE
C--------
C After loop, test for completion and go back to 1701 if not complete.
C--------
      IF(KORDCH .EQ. 0) KORDCM = 1
      IF(KTYPCH .EQ. 0) KTYPCM = 1
      IF(KORDCM.EQ.0 .OR. KTYPCM.EQ.0) GO TO 1701
C--------
C If all equations not ordered then print error message
C--------
      IF(KEQUP2 .GT. MEQLIM) GO TO 1739
      CALL ERRMSG(29, MEQLIM)
      WRITE(IOLIST,1735)
 1735 FORMAT(/'     The possible undefined variables are:-'/)
      INOUTP = 3
      INOUT(1) = 45
      INOUT(2) = 45
      INOUT(3) = 45
      DO 1738 I=3,NVARS
      IF(I.EQ.NTYP2) GO TO 1738
      IF(MVAR(I).EQ.0 .OR. MVAR(I+NVAR4).EQ.4) GO TO 1738
      IPOINT = I + MAXSIZ
      CALL OTRANS(IPOINT,0,0,0,DCONS,INOUT,MND,MVAR)
      DO 1736 K=1,4
      MTEMP2 = INOUT(INOUTP-K)
      IF(MTEMP2.EQ.41) GO TO 1737
 1736 CONTINUE
      K = 1
 1737 INOUT(INOUTP-K) = 46
      INOUT(INOUTP-K+1) = 45
      INOUTP = INOUTP - K + 2
 1738 CONTINUE
      INOUT(INOUTP-1) = 50
      CALL OUTLIN(INOUT,IOLIST)
      MRUN = 0
 1739 DO 1740 I=1,NVARS
 1740 MVAR(I+NVAR4) = 0
      IF(KDUMP.GT.1) WRITE(IOLIST,1741)KECOND, NVARS
 1741 FORMAT(' NVARS used',I5,', versus limit of',I5)
      IF(KECOND.GT.NVARS) STOP
      RETURN
C--------
C  end EQSORT
C--------
      END
C MULOPT SUBROUTINE
C ------ ----------
C This subroutine performs various housekeeping functions and
C    optimizes multiplication operations.
C***************
      SUBROUTINE MULOPT(KEY,DCONS,MTRPL,INOUT,MND,MVAR,MEQU)
C********
      DIMENSION DCONS(1),MTRPL(1),INOUT(2),MND(1),MVAR(2),MEQU(1),
     A MSUBR(17)
      DOUBLE PRECISION DCONS
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      COMMON/INPUT/NOPRT,KINDEX,IBLOK,ICONV(76)
      COMMON /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      COMMON /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
      CHARACTER*1 IBLOK,ICONV
      SAVE NEXT,NORDER,LINEAR,MSUBR
      DATA MSUBR/45,45,45,45,45,45,19,21,2,18,15,21,20,9,14,5,45/
      NVAR3 = NVARS*2
      NVAR4 = NVARS*3
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      MXSIZ = MAXSIZ/10
      IF(KEY.EQ.2) GO TO 1818
      NEXT = INOUT(1)
C--------
C Looking for linear system of ODE's
C  also finding and loading the maximum DIFF-order
C--------
      NORDER = 0
      LINEAR = 1
      KINDEX = 0
      DO 1806 IND=1,NEXT
      IF(MTRPL(IND).EQ.50) GO TO 1807
      NTC = MTRPL(IND+NOP4)
      NTC = NTC - (NTC/16)*16
      NT1 = NTC/4
      NT2 = NTC - NT1*4
      NTC = MTRPL(IND)
      IF(NTC.EQ.14) GO TO 1805
      IF(NTC.LT.32) GO TO 1804
      IF(NTC.EQ.48) GO TO 1803
      IF(NTC.EQ.39) GO TO 1801
      IF(NTC.EQ.40) GO TO 1802
      GO TO 1806
 1801 IF(NT1.NE.1 .AND. NT2.NE.1) LINEAR = 0
      GO TO 1806
 1802 IF(NT2.NE.1) LINEAR = 0
      GO TO 1806
 1803 IF(NT1.NE.1 .OR. NT2.NE.1) LINEAR = 0
      GO TO 1806
 1804 IF(NT1.NE.1) LINEAR = 0
      GO TO 1806
 1805 NDIFF = (MTRPL(IND+NOP3) - MAXSIZ)/MXSIZ
      IF(NDIFF.GT.NORDER) NORDER = NDIFF
 1806 CONTINUE
 1807 MTEMP5 = NORDER*100
      DO 1812 IND=1,NEXT
      NTC = MTRPL(IND+NOP3)
      IF(NTC.LT.3*MAXSIZ) GO TO 1812
      DO 1808 K=1,NEXT
      NT1 = IND + K
      IF(MTRPL(NT1).NE.44) GO TO 1808
      NT2 = MTRPL(NT1+NOPS)
      IF(NT2.GT.MAXSIZ) GO TO 1809
      NT1 = MTRPL(NT2)
      IF(NT1.EQ.14) GO TO 1811
 1808 CONTINUE
 1809 NT1 = NTC - 3*MAXSIZ
      IF(NT1.LT.NORDER) GO TO 1811
      WRITE(IOLIST,1810)
 1810 FORMAT(' A RH-side DIFF has an order that is too high.')
      STOP
 1811 MTRPL(IND+NOP3) = MTEMP5 + NTC
 1812 CONTINUE
      IF(NORDER.EQ.9) NORDER = 0
      INOUT(1) = LINEAR
      INOUT(2) = NORDER
C Looking for constants in a product.
      DO 1817 K=1,NEXT
      NTC = MTRPL(K)
      IF(NTC.NE.39) GO TO 1817
      NT2 = MTRPL(K+NOP3)
      IF(NT2.GE.3*MAXSIZ) GO TO 1817
      NT1 = MTRPL(K+NOP4)
      IF(NT1.EQ.63) GO TO 1817
      NTYPE3 = NT1/16
      IF(NTYPE3.NE.3) GO TO 1817
      NTYPE2 = NT1 - NTYPE3*16
      NTYPE1 = NTYPE2/4
      NTYPE2 = NTYPE2 - NTYPE1*4
      IF(NTYPE2.NE.1) GO TO 1817
      WRITE(IOLIST,1813)
 1813 FORMAT(' In a product, all constants must be placed first before'/
     A '   all functions.  Please check the constant named below.')
      DO 1814 II=1,7
 1814 INOUT(II) = 45
      INOUTP = 8
C For an address, I must trace back to both branches.
      NAME = MTRPL(K+NOP3)
      IF(NAME.GT.MAXSIZ) GO TO 1816
      MTEMP1 = MTRPL(NAME+NOPS)
      IF(MTEMP1.LT.MAXSIZ) GO TO 1815
      NAME = MTEMP1
      GO TO 1816
 1815 MTEMP1 = MTRPL(NAME+NOP3)
      NAME = MTEMP1
 1816 CALL OTRANS(NAME,0,0,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP-1) = 50
      CALL OUTLIN(INOUT,IOLIST)
      STOP
 1817 CONTINUE
      RETURN
C--------
C Locate the DIFF triplets on the LHS of equal signs
C--------
 1818 MDIFFP = 0
      DO 1819 MM=1,NEXT
      MOP = MTRPL(MM)
      IF(MOP.EQ.50) GO TO 1820
      IF(MOP.NE.44) GO TO 1819
      MTEMP2 = MTRPL(MM+NOPS)
      IF(MTEMP2.GT.MAXSIZ) GO TO 1819
      MDIFFP = MDIFFP + 1
      MEQU(MDIFFP+NVARS) = MTEMP2
      MTEMP2 = MTRPL(MTEMP2+NOPS) - MAXSIZ
      MVAR(MTEMP2+NVAR4) = 1
      IF(MVAR(MTEMP2).NE.10180) GO TO 1819
      MTOP = MTEMP2
 1819 CONTINUE
 1820 MTEMP2 = MAX0(8,NORDER+7)
      LENVAR = LENVAR + MTEMP2
C--------
C Write message concerning linear ODE
C--------
      IF(KFNCT.EQ.1) GO TO 1822
      IF(LINEAR.EQ.0) GO TO 1829
      WRITE(IOOBJE,1821)
      WRITE(IOLIST,1821)
 1821 FORMAT('C The ODE, system of ODE, entered is linear.'
     A /'C   MSTIFF has been set to 10.')
      GO TO 1829
C--------
C Write subroutine fct---(kterm,base,key,flag,top)
C--------
 1822 IF(KOMPLX.EQ.0) GO TO 1824
      WRITE(IOLIST,1823)
 1823 FORMAT('  ATOMFT is not yet able to do complex functions.')
      STOP
 1824 WRITE(IOOBJE,1825)
 1825 FORMAT('C--------')
      LINEAR = 0
      MOUT = 1
 1826 MOUT = MOUT + 1
      IF(MVAR(MOUT).NE.0) GO TO 1826
      MVAR(MOUT) = 10180
      MVAR(MOUT+NVARS) = 24860
      MVAR(MOUT+NVAR3) = 2
      MBASE = MOUT
 1827 MBASE = MBASE + 1
      IF(MVAR(MBASE).NE.0) GO TO 1827
      MVAR(MBASE) = 3259
      MVAR(MBASE+NVARS) = 8240
      MVAR(MBASE+NVAR3) = 2
      DO 1828 k=1,17
 1828 INOUT(K) = MSUBR(K)
      INOUTP = 18
      MVAR(MTOP) = 9740
      MV1 = MTOP + MAXSIZ
      CALL OTRANS(MV1,0,0,0,DCONS,INOUT,MND,MVAR)
      MVAR(MTOP) = 10180
      INOUT(INOUTP-3) = 11
      INOUT(INOUTP-2) = 20
      INOUT(INOUTP-1) = 5
      INOUT(INOUTP) = 18
      INOUT(INOUTP+1) = 13
      INOUT(INOUTP+2) = 46
      INOUTP = INOUTP + 3
      MV2 = MBASE + MAXSIZ
      CALL OTRANS(MV2,0,0,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP-4) = 46
      INOUT(INOUTP-3) = 11
      INOUT(INOUTP-2) = 5
      INOUT(INOUTP-1) = 25
      INOUT(INOUTP) = 46
      INOUT(INOUTP+1) = 11
      INOUT(INOUTP+2) = 6
      INOUT(INOUTP+3) = 12
      INOUT(INOUTP+4) = 1
      INOUT(INOUTP+5) = 7
      INOUT(INOUTP+6) = 46
      INOUTP = INOUTP + 7
      MV1 = MOUT + MAXSIZ
      CALL OTRANS(MV1,0,0,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP-4) = 46
      INOUT(INOUTP-3) = 16
      INOUT(INOUTP-2) = 8
      INOUT(INOUTP-1) = 42
      INOUT(INOUTP) = 50
      CALL OUTLIN(INOUT,IOOBJE)
      INOUT(2) = MTOP + MAXSIZ
 1829 INOUT(1) = MDIFFP
      RETURN
C--------
C end MULOPT
C--------
      END
C FORMAT SUBROUTINE
C ------ ----------
C This subroutine has two tasks: (1) separate the constant expressions
C  from the non-constant expressions and (2) isolate the operations that
C  require DO-loops for computation.
C***************
      SUBROUTINE FORMAT(MTRPL,INOUT,MND,MVAR,MEQU)
C***************

C MSF:
C     Microsoft Fortran version 5.1 requires the [NEAR] attribute:
c      DIMENSION MTRPL(1),INOUT(1),MVAR(1),MEQU(1),MND(1),LTYPE[NEAR](3)
      DIMENSION MTRPL(1),INOUT(1),MVAR(1),MEQU(1),MND(1),LTYPE(3)

      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/TYPODR/LNL(48),LNL1(3,3,4),KORDJ(48),KRES(48),
     B KRES1(3,3,4),KRES2(3),KITR1(3,3,4),KITR2(3,3)
     D /OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
     E /FLAGS/MRUN,MVCNT /IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
     E /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      EQUIVALENCE (LTYPE(1),LT1),(LTYPE(2),LT2),(LTYPE(3),LT3)
      DATA MSTKP/1/,LGEN/1/
      NVAR3 = NVARS*2
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      DO 1901 IND=1,NOPS
      INOUT(IND) = 0
      INOUT(IND+NOPS) = 1
 1901 MND(IND) = 0
C--------
C The MND(ind) array is used to indicate when a variable has been
C  evaluated in a previous equation.  Thus, duplication is avoided.
C--------
      LCEQP = 1
      MEQLIM = MSTK(1)
      NEXT = 1 - MEQU(MEQLIM)
      LREQP = 1
      DO 1928 MEQP=1,MEQLIM
      MTRPLP = MEQU(MEQP+NVARS)
      MSTKP = 1
      LAST = MTRPLP
      LT2 = (MTRPL(MTRPLP+NOP4) - (MTRPL(MTRPLP+NOP4)/16)*16)/4
      IF(LT2 .GT. 1) GO TO 1903
      MEQU(LCEQP+NVAR3) = MTRPLP
      LCEQP = LCEQP + 1
      GO TO 1928
C--------
C Look for stored branches in MSTK
C--------
 1902 IF(MSTKP.LT.3) GO TO 1927
      INOUT(MTRPLP) = 1
      MSTKP = MSTKP - 2
      MTRPLP = MSTK(MSTKP+1)
      LAST = MSTK(MSTKP)
      LGEN = INOUT(LAST+NOPS)
      IF(INOUT(MTRPLP).EQ.1) GO TO 1902
C--------
C Get all pointers
C--------
 1903 LOP = MTRPL(MTRPLP)
      LOPL = LOPLIM(LOP) + 1
      LT1 =  MTRPL(MTRPLP+NOP4)/16
      LT2 = (MTRPL(MTRPLP+NOP4) - LT1*16)/4
      LT3 =  MTRPL(MTRPLP+NOP4) - LT1*16 - LT2*4
C--------
C Process constant expressions.
C--------
      IF(LOPL.LT.2) GO TO 1907
      DO 1906 MTEMP1=2,LOPL
      MTP = MTRPLP + NOPS*(MTEMP1 - 1)
      MTEMP2 = MTRPL(MTP)
      IF(MTEMP2.GT.MAXSIZ .OR. LTYPE(MTEMP1).GT.1) GO TO 1906
      IF(MND(MTEMP2) .EQ. 0) GO TO 1904
C--------
C MND(MTEMP2) prevents duplicate triplets for constants.
C--------
      MGVAR = MND(MTEMP2)
      GO TO 1905
 1904 CALL VARGEN(MGVAR,1,MVAR)
      IF(MRUN .NE. 1) GO TO 1929
      MEQU(LCEQP+NVAR3) = NEXT
      LCEQP = LCEQP + 1
      CALL TRPGEN(NEXT,44,MGVAR,MTEMP2,21,MTRPL)
      IF(MRUN .NE. 1) GO TO 1929
      MND(MTEMP2) = MGVAR
 1905 MTP = MTRPLP + NOPS*(MTEMP1 - 1)
      MTRPL(MTP) = MGVAR
 1906 CONTINUE
C--------
C Determine LNEW
C--------
 1907 IF(LOP .LT. 37) LT3 = 2
      MTEMP1 = LNL(LOP)
      MT2 = LT2
      MT3 = LT3
      LNEW = LNL1(MT2,MT3,MTEMP1)
C--------
C Determine LSAT
C--------
      LUNSAT = 1
      MTEMPL = MTRPL(MTRPLP+NOPS)
      IF(MTEMPL.GT.MAXSIZ) GO TO 1908
      IF(INOUT(MTEMPL).EQ.0) LUNSAT = 2
 1908 IF(LOPL .LT. 3) GO TO 1909
      MTEMPR = MTRPL(MTRPLP+NOP3)
      IF(MTEMPR.GT.MAXSIZ) GO TO 1909
      IF(INOUT(MTEMPR).EQ.0) LUNSAT = LUNSAT + 2
C--------
C Implied operands/operators
C--------
 1909 IF(MTRPL(LAST).NE.44 .OR. LUNSAT.GT.1 .OR.
     A  LIMPLI(LOP).LE.0) GO TO 1910
      CALL IMPLOP(NEXT,LREQP,LCEQP,MTRPLP,LAST,MTRPL,MVAR,MEQU)
      IF(MRUN .NE. 1) GO TO 1929
C--------
C Determine LGEN
C--------
 1910 IF(LUNSAT.NE.1) GO TO 1911
      JUMP = LGEN + LNEW
      IF(JUMP.GT.1) GO TO 1917
      GO TO 1902
 1911 LGEN = 1
      IF(LNEW.EQ.2) LGEN = 2
      GO TO (1903,1916,1912,1914), LUNSAT
 1912 KFLIP = 1
      GO TO 1915
 1913 LAST = MTRPLP
      MTRPLP = MTRPL(MTRPLP+NOP3)
      GO TO 1903
C--------
C Both branches needs attention; so, save both in MSTK
C--------
 1914 KFLIP = 0
      MSTK(MSTKP) = MTRPLP
      MSTK(MSTKP + 1) = MTRPL(MTRPLP+NOP3)
      INOUT(MTRPLP+NOPS) = LGEN
      LHOLD =LGEN
      LGEN = 1
      MSTKP = MSTKP + 2
 1915 MSTK(MSTKP) = MTRPLP
      MSTK(MSTKP + 1) = MTRPL(MTRPLP+NOP3)
      INOUT(MTRPLP+NOPS) = LGEN
      MSTKP = MSTKP + 2
      IF(KFLIP.EQ.1) GO TO 1913
      LGEN = LHOLD
 1916 MSTK(MSTKP) = MTRPLP
      MSTK(MSTKP + 1) = MTRPL(MTRPLP+NOPS)
      INOUT(MTRPLP+NOPS) = LGEN
      MSTKP = MSTKP + 2
      LAST = MTRPLP
      MTRPLP = MTRPL(MTRPLP+NOPS)
      GO TO 1903
C--------
C Look for all pointers needed to process a triplet
C--------
 1917 IF(MTRPL(LAST).EQ.44) GO TO 1927
      LAST2 = LAST
      LSTART = MTRPLP
      MTEMP1 = LSTART
      IF(LUNSAT.EQ.1 .OR. LUNSAT.EQ.3) GO TO 1918
      MTEMP3 = (MTRPL(LSTART+NOP4) - (MTRPL(LSTART+NOP4)/16)*16)/4
      MTEMP2 = 2
      GO TO 1921
 1918 IF(LUNSAT.LT.3 .OR. LOPL.EQ.2) GO TO 1919
      MTEMP3 = MTRPL(LSTART+NOP4) - (MTRPL(LSTART+NOP4)/4)*4
      MTEMP2 = 3
      GO TO 1921
 1919 IF(MTRPL(LAST).NE.44) GO TO 1920
      MGVAR = MTRPL(LAST+NOPS)
      LSTART = MTRPL(LAST+NOP3)
      GO TO 1926
 1920 MTEMP1 = LAST2
      MTEMP3 = MTRPL(LSTART+NOP4)/16
      MTEMP2 = 2
      IF(MTRPL(LAST2+NOPS) .NE. LSTART) MTEMP2 = 3
C--------
C Begin processing triplets.
C--------
 1921 MTP = MTEMP1 + NOPS*(MTEMP2 - 1)
      LSTART = MTRPL(MTP)
      IF(MND(LSTART) .EQ. 0) GO TO 1922
C--------
C Here, MND(LSTART) prevents generation of duplicate triplets
C--------
      MGVAR = MND(LSTART)
      GO TO 1925
 1922 MFNT = MTRPL(LSTART)
      IF(MFNT.NE.13) GO TO 1923
      MGVAR = MTRPL(LSTART+NOP3)
      GO TO 1924
 1923 CALL VARGEN(MGVAR,MTEMP3,MVAR)
      IF(MRUN .NE. 1) GO TO 1929
 1924 MTEMP3 = MTEMP3*21
      LAST2 = NEXT
      MEQU(LREQP) = NEXT
      LREQP = LREQP + 1
      CALL TRPGEN(NEXT,44,MGVAR,LSTART,MTEMP3,MTRPL)
      IF(MRUN .NE. 1) GO TO 1929
      MND(LSTART) = MGVAR
 1925 MTP = MTEMP1 + NOPS*(MTEMP2 - 1)
      MTRPL(MTP)  = MGVAR
 1926 INOUT(LSTART) = 1
      LGEN = 1
      MTEMP1 = MTRPL(LSTART)
      IF(LIMPLI(MTEMP1) .LE. 0) GO TO 1902
      CALL IMPLOP(NEXT,LREQP,LCEQP,LSTART,LAST2,MTRPL,MVAR,MEQU)
      IF(MRUN .NE. 1) GO TO 1929
      GO TO 1902
C--------
C All done in this loop.  Go to the next loop.
C--------
 1927 MEQU(LREQP) = MEQU(MEQP+NVARS)
      LREQP = LREQP + 1
 1928 CONTINUE
      MSTK(198) = NEXT
      MSTK(199) = LCEQP
      MSTK(200) = LREQP
      MTRPL(NEXT) = 50
 1929 IF(KDUMP.GT.1) WRITE(IOLIST,1930)NEXT, NOPS
 1930 FORMAT(' NOPS used',I6,', versus limit of',I6)
      IF(NEXT.GT.NOPS) STOP
      RETURN
C--------
C end FORMAT
C--------
      END
C DIMGEN SUBROUTINE
C ------ ----------
C This subroutine generates all the non-executable statements and the
C  DATA statement.
C***************
      SUBROUTINE DIMGEN(MDIFFP,NORDER,DCONS,MINDV,MTRPL,INOUT,MND,MVAR,
     A MEQU)
C***************
      DIMENSION DCONS(1),MTRPL(1),INOUT(21),MVAR(1),MEQU(1),MINDV(1),
     A MND(1),MDM(18,4),MSHIFT(5),MEQUIV(12),MKONT(10),MWK(46),MWK2(39)
      DOUBLE PRECISION DCONS
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
     a /IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
     E /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
     C /FUNCTN/IFUNC(31,4)
     D /OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
     E /FLAGS/MRUN,MVCNT
      DATA MSHIFT/19,8,9,6,20/
      DATA MDM/10,4,9,13,5,14,19,9,15,14,8*45,17,4,15,21,2,12,5,45,16,
     A 18,5,3,9,19,9,15,14,45,8,3,15,13,16,12,5,24,10*45,11,3,15,13,16,
     B 12,5,24,39,28,33,7*45/
      DATA MEQUIV/5,17,21,9,22,1,12,5,14,3,5,45/
      DATA MKONT/11,15,14,20,18,12,40,28,40,50/
      DATA MWK/45,45,45,45,45,45,4,15,21,2,12,5,45,16,18,5,3,9,19,9,15,
     A 14,45,23,11,41,28,35,30,27,42,49,45,45,45,45,45,45,19,1,22,5,45,
     A 23,11,50/
      DATA MWK2/45,45,45,45,45,45,4,9,13,5,14,19,9,15,14,45,23,11,41,28,
     A 35,30,27,42,49,45,45,45,45,45,45,19,1,22,5,45,23,11,50/
      NVAR3 = NVARS*2
      NVAR4 = NVARS*3
      NOP3 = NOPS*2
      MXSIZ = MAXSIZ/10
      KTEMP = 1 + MAXSIZ
      NCOUNT = 0
      DO 2001 I=1,6
 2001 INOUT(I) = 45
      DO 2002 I=7,18
C EQUIVALENCE
 2002 INOUT(I) = MEQUIV(I-6)
      M = 0
 2003 INOUTP = 19
 2004 M = M + 1
C (TMPS(1,
      INOUT(INOUTP) = 41
      INOUT(INOUTP+1) = 20
      INOUT(INOUTP+2) = 13
      INOUT(INOUTP+3) = 16
      INOUT(INOUTP+4) = 19
      INOUT(INOUTP+5) = 41
      INOUT(INOUTP+6) = 28
      INOUT(INOUTP+7) = 46
      INOUTP = INOUTP + 8
      IF(M.GT.9) GO TO 2005
      KM = 1
      MM = M
      GO TO 2008
 2005 IF(M.GT.99) GO TO 2006
      MM = M/10
      MN = M - MM*10
      KM = 2
      GO TO 2007
 2006 MM = M/100
      MK = M - MM*100
      MN = MK/10
      MO = MK - MN*10
      KM = 3
      INOUT(INOUTP+2) = MO+27
 2007 INOUT(INOUTP+1) = MN+27
 2008 INOUT(INOUTP) = MM+27
      INOUTP = INOUTP + KM
C ),
      INOUT(INOUTP) = 42
      INOUT(INOUTP+1) = 46
      INOUTP = INOUTP + 2
      MTEMP1 = MEQU(M+NVARS)
      MTEMP1 = MTRPL(MTEMP1+NOPS)
      CALL OTRANS(MTEMP1,1,0,0,DCONS,INOUT,MND,MVAR)
C ),
      INOUT(INOUTP-1) = 42
      INOUT(INOUTP) = 46
      INOUTP = INOUTP + 1
      IF(INOUTP.GT.700) GO TO 2009
      IF(M.LT.MDIFFP) GO TO 2004
 2009 INOUT(INOUTP-1) = 50
      CALL OUTLIN(INOUT,IOOBJE)
      IF(M.LT.MDIFFP) GO TO 2003
      DO 2010 M=1,MDIFFP
        MTEMP1 = MEQU(M+NVARS)
        MTEMP1 = MTRPL(MTEMP1+NOPS) - MAXSIZ
        NCOUNT = NCOUNT + 1
 2010 CONTINUE
      KCOUNT = NCOUNT + 1
C--------
C Generate the 'DIMENSION' and 'DOUBLE PRECISION' statement.
C--------
      MSTART = 1
      ICHOS = KDOBLE + 2*KOMPLX + 1
      MTEMP3 = MDM(1,ICHOS) + 7
      DO 2011 I=7,MTEMP3
 2011 INOUT(I) = MDM(I-5,ICHOS)
 2012 INOUTP = MTEMP3
      MTEMP4 = MAX0(8,NORDER+7)
      MTEMP2 = KCOUNT
      DO 2018 M=MSTART,NVARS
        IF(M.EQ.1 .AND. ICHOS.NE.1) GO TO 2018
        IF(M .EQ. 1) GO TO 2017
        MM = MVAR(M)
        IF(MM.GE.14400 .AND. MM.LT.24000) GO TO 2018
        IF(MM.EQ.0) GO TO 2018
        IF(ICHOS.EQ.1 .AND. MVAR(M+NVAR3).LT.2) GO TO 2018
C--------
C Looking for double precision non-array variables.
C--------
        IF(MVAR(M+NVAR3).LT.2) GO TO 2013
C--------
C Determine size of array.
C--------
        MTEMP2 = 2
        IF(MVAR(M+NVAR3) .LE. 2) GO TO 2014
        MTEMP2 = LENVAR - MTEMP4
        IF(MVAR(M+NVAR4) .EQ. 0) GO TO 2017
        MTEMP2 = LENVAR
        GO TO 2017
 2013   MTEMP2 = 0
        IF(KOMPLX .EQ. 1) GO TO 2018
        GO TO 2017
 2014   DO 2015 MMT=1,NEQUS
          MNT = MMT + NEQUS
          IF(MINDV(MNT) .EQ. M) GO TO 2016
 2015   CONTINUE
        GO TO 2017
C Match. This is the independent variable.
 2016   INDVP = M
C--------
C Generate the variable name.
C--------
 2017   MTEMP1 = M + MAXSIZ
        CALL OTRANS(MTEMP1,MTEMP2,0,0,DCONS,INOUT,MND,MVAR)
        INOUT(INOUTP-1) = 46
        INOUT(INOUTP) = 45
        INOUTP = INOUTP + 1
        IF(INOUTP .GT. 700) GO TO 2019
 2018 CONTINUE
C--------
C Print the generated statement.  Restart loop if not finished.
C--------
 2019 INOUT(INOUTP-2) = 50
      CALL OUTLIN(INOUT,IOOBJE)
      MSTART = M + 1
      IF(M .LT.NVARS) GO TO  2012
      IF(ICHOS.EQ.1) GO TO 2023
C--------
C Generate the double precision functions.
C--------
      INOUTP = MTEMP3
      DO 2020 M=1,31
        MTF = IFUNC(M,3)
        IF(MTF.GE.0 .OR. M.EQ.14) GO TO 2020
        IFUNC(M,3) = - MTF
        CALL OTRANS(M,0,0,0,DCONS,INOUT,MND,MVAR)
        INOUT(INOUTP-1) = 46
        INOUT(INOUTP) = 45
        INOUTP = INOUTP + 1
 2020 CONTINUE
C--------
C This DO loop is for generating double stmt for shift and HNEW'S.
C--------
      DO 2021 MTEMP5=1,5
        INOUT(INOUTP) = MSHIFT(MTEMP5)
 2021 INOUTP = INOUTP + 1
      INOUT(INOUTP) = 46
      INOUT(INOUTP+1) = 45
      INOUTP = INOUTP + 2
      INOUT(INOUTP-2) = 50
      CALL OUTLIN(INOUT,IOOBJE)
      DO 2022 MMT=2,11
        INOUTP = MMT + 5
 2022 INOUT(INOUTP) = MDM(MMT,1)
      INOUTP = INOUTP + 1
C DIMENSION NAMES
      CALL OTRANS(KTEMP,KCOUNT,0,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP-1) = 50
      CALL OUTLIN(INOUT,IOOBJE)
 2023 IF(KFNCT.EQ.1) THEN
        IF(KDOBLE .EQ. 1) THEN
          DO 2024 M=1,46
 2024     INOUT(M) = MWK(M)
        ELSE
          DO 2025 M=1,39
 2025     INOUT(M) = MWK2(M)
        CALL OUTLIN(INOUT,IOOBJE)
        ENDIF
      ENDIF
C DATA
      INOUT(7) = 4
      INOUT(8) = 1
      INOUT(9) = 20
      INOUT(10) = 1
      INOUT(11) = 45
C KONTRL/1/
      IF(KFNCT.EQ.1) THEN
        DO 2026 M=1,10
 2026   INOUT(M+11) = MKONT(M)
        CALL OUTLIN(INOUT,IOOBJE)
      ENDIF
      NDIFFP = MDIFFP + 1
      DO 2037 M=1,NDIFFP
        INOUTP = 12
C DATA NAMES
        CALL OTRANS(KTEMP,M,0,0,DCONS,INOUT,MND,MVAR)
        INOUT(INOUTP-1) = 40
        IF(M.EQ.1) GO TO 2027
C--------
C For each variable, this loop places its name in the temporary array
C  in A6 format.
C--------
        MA = M - 1
        MTEMP1 = MEQU(MA+NVARS)
        MTEMP1 = MTRPL(MTEMP1+NOPS) - MAXSIZ
        GO TO 2028
 2027   MTEMP1 = INDVP
 2028   MTEMP2 = MVAR(MTEMP1+NVARS)
        MTEMP1 = MVAR(MTEMP1)
C--------
C For variable name 'ABCDEF' the following generates: 6hABCDEF
C--------
C quote
        INOUT(INOUTP) = 43
        MTEMP3 = MTEMP1/1600
        MTEMP1 = MTEMP1 - MTEMP3*1600
        IF(MTEMP3 .GT. 0) GO TO 2030
        IF(MTEMP1 .EQ. 0) GO TO 2029
        MTEMP3 = MTEMP3 - 1
        MTEMP1 = MTEMP1 + 1600
 2029   MTEMP3 = MTEMP3 + 40
C first character
 2030   IADD = 1
        INOUT(INOUTP+IADD) = MTEMP3
        MTEMP3 = MTEMP1/40
        IF(MTEMP3 .EQ. 0) GO TO 2033
        IADD = 2
        INOUT(INOUTP+IADD) = MTEMP3
        MTEMP3 = MTEMP1 - MTEMP3*40
        IF(MTEMP3 .EQ. 0) GO TO 2033
        IADD = 3
        INOUT(INOUTP+IADD) = MTEMP3
        MTEMP3 = MTEMP2/1600
        MTEMP2 = MTEMP2 - MTEMP3*1600
        IF(MTEMP3 .GE. 0) GO TO 2032
        IF(MTEMP2 .EQ. 0) GO TO 2031
        MTEMP3 = MTEMP3 - 1
        MTEMP2 = MTEMP2 + 1600
 2031   MTEMP3 = MTEMP3 + 40
 2032   IF(MTEMP3 .EQ. 0) GO TO 2033
        IADD = 4
        INOUT(INOUTP+IADD) = MTEMP3
        MTEMP3 = MTEMP2/40
        IF(MTEMP3 .EQ. 0) GO TO 2033
        IADD = 5
        INOUT(INOUTP+IADD) = MTEMP3
        MTEMP3 = MTEMP2 - MTEMP3*40
        IF(MTEMP3 .EQ. 0) GO TO 2033
        IADD = 6
        INOUT(INOUTP+IADD) = MTEMP3
C--------
C A zero marks a trailing blank character in the name.
C--------
C quote,
 2033   IF(IADD .EQ. 6) GO TO 2036
        DO 2034 K=1,IADD
 2034   INOUT(INOUTP+7-K) = INOUT(INOUTP+IADD+1-K)
        MOVE = 6 - IADD
        DO 2035 K=1,MOVE
 2035   INOUT(INOUTP+K) = 45
 2036   INOUT(INOUTP+7) = 43
        INOUTP = INOUTP + 9
C--------
C Now print the data statment just generated
C--------
C /
        INOUT(INOUTP-1) = 40
        INOUT(INOUTP) = 50
        CALL OUTLIN(INOUT,IOOBJE)
 2037 CONTINUE
C--------
C This loop generates the assignment statements for the names passed
C  to 'RDCV'.
C--------
      IF(MDIFFP .LT. 1) GO TO 2042
      DO 2041 M=1,MDIFFP
        MTEMP1 = MEQU(M+NVARS)
        MTEMP5 = MTRPL(MTEMP1+NOPS) - MAXSIZ
        INOUTP = 7
        MTEMP2 = LENVAR - 5
        MTEMP4 = MTEMP5 + MAXSIZ
        CALL OTRANS(MTEMP4,MTEMP2,0,0,DCONS,INOUT,MND,MVAR)
        MTEMP5 = (MTRPL(MTEMP1+NOP3) - MAXSIZ)/MXSIZ
        INOUT(INOUTP) = 44
        INOUT(INOUTP+1) = 45
        INOUTP = INOUTP + 2
        MTEMP3 = M + 1
        IF(MTEMP3.LT.100) GO TO 2038
        MTEMP2 = MTEMP3/100
        INOUT(INOUTP) = MTEMP2 + 27
        INOUTP = INOUTP + 1
        MTEMP3 = M - MTEMP2*100
        GO TO 2039
 2038   IF(MTEMP3.LT.10) GO TO 2040
 2039   MTEMP2 = MTEMP3/10
        INOUT(INOUTP) = MTEMP2 + 27
        INOUTP = INOUTP + 1
        MTEMP3 = MTEMP3 - MTEMP2*10
 2040   INOUT(INOUTP) = MTEMP3 + 27
        INOUT(INOUTP+1) = 47
        INOUT(INOUTP+2) = 27 + MTEMP5
        INOUT(INOUTP+3) = 28
        INOUT(INOUTP+4) = 50
        CALL OUTLIN(INOUT,IOOBJE)
 2041 CONTINUE
C--------
C end DIMGEN
C--------
 2042 RETURN
      END
C TRPGEN SUBROUTINE
C ------ ----------
C This subroutine generates triplets.
C***************
      SUBROUTINE TRPGEN(NEXT,I1,I2,I3,I4,MTRPL)
C***************
      DIMENSION MTRPL(1)
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      MTRPL(NEXT) = I1
      MTRPL(NEXT+NOPS) = I2
      MTRPL(NEXT+NOP3) = I3
      MTRPL(NEXT+NOP4) = I4
      NEXT = NEXT + 1
      RETURN
C--------
C end TRPGEN
C--------
      END
C IMPLOP SUBROUTINE
C ------ ----------
C This subroutine generates the implied operators and operands.
C***************
      SUBROUTINE IMPLOP(NEXT,LREQP,LCEQP,MTRPLP,LAST,MTRPL,MVAR,MEQU)
C***************
      DIMENSION MTRPL(1),MVAR(1),MEQU(1),LFCN(31)
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/OUTPUT/LOOPNX,LOPLIM(48),LITNUM,LITKNT,LIMPLI(48)
     B /FUNCTN/IFUNC(31,4) /FLAGS/MRUN,MVCNT
      SAVE LFCN
      DATA LFCN/4*0,27,17*0,26,2*0,23,5,4*0/
      NVAR3 = NVARS*2
      NOP3 = NOPS*2
      NOP4 = NOPS*3
C--------
C Branch to correct group
C--------
      LOP = MTRPL(MTRPLP)
      JUMP = LIMPLI(LOP)
      GO TO (2101,2102,2105,2111,2112), JUMP
C--------
C This section generates implied operands for SIN(H) and COS(H).
C--------
 2101 CALL VARGEN(MGVAR,3,MVAR)
      IF(MRUN .NE. 1) GO TO 2112
      MTEMP1 = LFCN(LOP)
      MTEMP2 = NEXT
      MTEMP3 = 51 + MTRPL(MTRPLP+NOP4) - (MTRPL(MTRPLP+NOP4)/16)*16
      MTEMP4 = MTRPL(MTRPLP+NOPS)
      MTEMP5 = MTRPL(LAST+NOPS)
      CALL TRPGEN(NEXT,MTEMP1,MTEMP4,MTEMP5,MTEMP3,MTRPL)
      IF(IFUNC(MTEMP1,3) .GT. 0) IFUNC(MTEMP1,3) = - IFUNC(MTEMP1,3)
      MEQU(LREQP) = NEXT
      LREQP = LREQP + 1
      CALL TRPGEN(NEXT,44,MGVAR,MTEMP2,63,MTRPL)
      MTRPL(MTRPLP+NOP3) = MGVAR
      MTRPL(MTRPLP+NOP4) = MTRPL(MTRPLP+NOP4)/4*4 + 3
      GO TO 2112
C--------
C This section generates the implied operands for the TAN and TANH.
C--------
 2102 CALL VARGEN(MTEMP1,3,MVAR)
      CALL VARGEN(MGVAR,3,MVAR)
      IF(MRUN .NE. 1) GO TO 2112
      MTEMP2 = 51 + MTRPL(MTRPLP+NOP4) - (MTRPL(MTRPLP+NOP4)/16)*16
      MTEMP3 = NEXT
      IF(LOP .EQ. 20) GO TO 2103
      MTEMP4 = 26
      MTEMP5 = 23
      GO TO 2104
 2103 MTEMP4 = 5
      MTEMP5 = 27
 2104 IF(IFUNC(MTEMP4,3) .GT. 0) IFUNC(MTEMP4,3) = - IFUNC(MTEMP4,3)
      IF(IFUNC(MTEMP5,3) .GT. 0) IFUNC(MTEMP5,3) = - IFUNC(MTEMP5,3)
      MTEMP6 = MTRPL(MTRPLP+NOPS)
      CALL TRPGEN(NEXT,MTEMP4,MTEMP6,MGVAR,MTEMP2,MTRPL)
      MEQU(LREQP) = NEXT
      LREQP = LREQP + 1
      CALL TRPGEN(NEXT,44,MTEMP1,MTEMP3,63,MTRPL)
      MTEMP3 = NEXT
      CALL TRPGEN(NEXT,MTEMP5,MTEMP6,MTEMP1,MTEMP2,MTRPL)
      MEQU(LREQP) = NEXT
      LREQP = LREQP + 1
      CALL TRPGEN(NEXT,44,MGVAR,MTEMP3,63,MTRPL)
      MTEMP3 = MTEMP1
      MTEMP1 = MGVAR
      MGVAR = MTEMP3
      MTEMP3 = MTRPLP
      CALL TRPGEN(MTEMP3,40,MTEMP1,MGVAR,63,MTRPL)
      IF(LAST-MTRPLP .LE. 1) GO TO 2112
      MTEMP1 = MEQU(LREQP-3)
      MEQU(LREQP-3) = MEQU(LREQP-2)
      MEQU(LREQP-2) = MEQU(LREQP-1)
      MEQU(LREQP-1) = MTEMP1
      GO TO 2112
C--------
C This section generates the implied operands and operations for **.
C--------
 2105 MTEMP3 = MTRPL(MTRPLP+NOP4) - (MTRPL(MTRPLP+NOP4)/4)*4
      IF(MTEMP3 .EQ. 1)GO TO 2112
      MTEMP1 = (MTRPL(MTRPLP+NOP4) - (MTRPL(MTRPLP+NOP4)/16)*16)/4
      MTEMP2 = MTEMP1
      IF(MTEMP1 .EQ. 2) MTEMP1 = 3
      CALL VARGEN(MGVAR,MTEMP1,MVAR)
      IF(MRUN .NE. 1) GO TO 2112
      IF(IFUNC(24,3) .GT. 0) IFUNC(24,3) = - IFUNC(24,3)
      IF(MTEMP1 .GT. 1) GO TO 2106
      MEQU(LCEQP+NVAR3) = NEXT
      LCEQP = LCEQP + 1
      GO TO 2108
 2106 IF(LAST-MTRPLP .LE. 1) GO TO 2107
      MEQU(LREQP) = MEQU(LREQP-1)
      MEQU(LREQP-1) = NEXT
      LREQP = LREQP + 1
      GO TO 2108
 2107 MEQU(LREQP) = NEXT
      LREQP = LREQP + 1
 2108 MTEMP4 = MTEMP1*21
      MTEMP5 = NEXT + 1
      CALL TRPGEN(NEXT,44,MGVAR,MTEMP5,MTEMP4,MTRPL)
      MTEMP4 = MTEMP1*17 + MTEMP2*4
      MTEMP6 = MTRPL(MTRPLP+NOPS)
      CALL TRPGEN(NEXT,24,MTEMP6,MGVAR,MTEMP4,MTRPL)
      IF(MTEMP2 .GT. 1) GO TO 2110
      MTEMP1 = MTEMP3*4 + MTEMP1
      MTEMP6 = MTRPL(MTRPLP+NOP3)
      CALL TRPGEN(NEXT,47,MTEMP6,MGVAR,MTEMP1,MTRPL)
      MTEMP2 = 1
 2109 MTRPL(MTRPLP+NOP3) = MTRPL(MTRPLP+NOPS)
      MTRPL(MTRPLP+NOPS) = NEXT - MTEMP2
      GO TO 2112
 2110 MTEMP4 = NEXT + 1
      MTEMP6 = MTRPL(MTRPLP+NOP3)
      CALL TRPGEN(NEXT,47,MTEMP4,MTEMP6,MTEMP3,MTRPL)
      CALL VARGEN(MTEMP4,MTEMP1,MVAR)
      CALL TRPGEN(NEXT,47,MGVAR,MTEMP4,15,MTRPL)
      MTEMP2 = 2
      GO TO 2109
C--------
C The implied operands for EXP, ALOG, and SQRT.
C--------
 2111 MTRPL(MTRPLP+NOP3) = MTRPL(LAST+NOPS)
      MTRPL(MTRPLP+NOP4) = MTRPL(MTRPLP+NOP4)/4*4 + 3
C--------
C  end IMPLOP
C--------
 2112 RETURN
      END
C DMPCVC SUBROUTINE
C ------ ----------
C This subroutine lists the constants and variables, and operator codes.
C***************
      SUBROUTINE DMPCVC(ICONSW,IVARSW,ICODSW,IEQUSW,DCONS,MTRPL,INOUT,
     A MND,MVAR,MEQU)
C***************
      DIMENSION DCONS(1),MTRPL(1),INOUT(55),MVAR(1),MEQU(1),MND(1)
      DOUBLE PRECISION DUNIQ,DCONS
      DIMENSION IOUT(80)
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/MACHIN/DUNIQ,MAXEXP,MAXD,IUNIX,NSDIGS,NDDIGS
      COMMON/ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
     A /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      NVAR3 = NVARS*2
      NVAR4 = NVARS*3
      NOP4 = NOPS*3
      MTEMP6 = INOUTP
      DO 2201 KK=1,80
 2201 IOUT(KK) = INOUT(KK)
      WRITE(IOLIST,2202)KDUMP,LENVAR,KDOBLE,KOMPLX
 2202 FORMAT(9X,10H***DUMP*** /14X,
     A  17HOPTIONS IN EFFECT /10X, 5HDUMP= , I2, 9H  LENVAR= ,
     B  I4,9H  DOUBLE= ,I2,9H COMPLEX= ,I2 )
C--------
C CONSTANTS
C--------
      IF(ICONSW .NE. 1) GO TO 2206
      WRITE(IOLIST,2203)
 2203 FORMAT(14X, 9HCONSTANTS /17X, 7HPOINTER,
     A    14X, 5HVALUE / )
      DO 2205 I=1, NEQUS
      IF(DCONS(I) .EQ. DUNIQ) GO TO 2205
      IPOINT = I + 2*MAXSIZ
      WRITE(IOLIST,2204) IPOINT, DCONS(I)
 2204 FORMAT(20X,I6,10X,1PD15.7)
 2205 CONTINUE
C--------
C VARIABLES
C--------
 2206 IF(IVARSW .NE. 1) GO TO 2211
      WRITE(IOLIST,2207)
 2207 FORMAT(14X,9HVARIABLES /17X,7HPOINTER,
     A   8X, 9HVARIABLE )
      DO 2208 I=1,55
 2208 INOUT(I) = 45
      INOUT(20) = 28
      INOUT(21) = 27
      DO 2210 I=1,NVARS
      IF(MVAR(I) .EQ. 0) GO TO 2210
      INOUTP = 35
      IPOINT = I + MAXSIZ
      KT = I/1000
      INOUT(22) = KT + 27
      KARY = I - KT*1000
      KT = KARY/100
      INOUT(23) = KT + 27
      KARY = KARY - KT*100
      KT = KARY/10
      INOUT(24) = KT + 27
      KARY = KARY - KT*10
      INOUT(25) = KARY + 27
      II = MVAR(I+NVAR3)
      CALL OTRANS(IPOINT,II,0,0,DCONS,INOUT,MND,MVAR)
      INOUT(52) = MVAR(I+NVAR4) + 27
      INOUT(55) = 50
      CALL OUTLIN(INOUT,IOLIST)
      DO 2209 J=35,55
 2209 INOUT(J) = 45
 2210 CONTINUE
C--------
C INTERMEDIATE CODE
C--------
 2211 IF(ICODSW .NE. 1) GO TO 2215
      WRITE(IOLIST,2212)
 2212 FORMAT(1H-,14X,4HCODE /1H0,1X,11HTRIPLET NO.,1X,
     A  8HOPERATOR,3X,12HOPERAND NO.1,3X,12HOPERAND NO.2,
     B  10X,5HTYPES /)
 2213 FORMAT(2X,I6,9X,I2,8X,I6,10X,I6,4X,3I6)
      DO 2214 I=1,NOPS
      IF(MTRPL(I) .EQ. 50) GO TO 2215
      ITYPE0 = MTRPL(I+NOP4)/16
      ITYPE1 = (MTRPL(I+NOP4) - ITYPE0*16)/4
      ITYPE2 = MTRPL(I+NOP4) - ITYPE0*16 - ITYPE1*4
      WRITE(IOLIST,2213) I,(MTRPL(I+NOPS*(J-1)),J=1,3),ITYPE0,ITYPE1,
     A ITYPE2
 2214 CONTINUE
C--------
C EQUATION POINTERS
C--------
 2215 IF(IEQUSW .EQ. 0) GO TO 2219
      WRITE(IOLIST,2216 )
 2216 FORMAT(1H-,14X,17HEQUATION POINTERS /1H0,17X,8HEQUATION,
     A   5X,11HTRIPLET NO.  )
 2217 FORMAT(20X,I4,10X,I4)
      DO 2218 I=1,IEQUSW
      WRITE(IOLIST,2217) I,MEQU(I)
 2218 CONTINUE
 2219 DO 2220 KK=1,80
 2220 INOUT(KK) = IOUT(KK)
      INOUTP = MTEMP6
C--------
C end DUMP
C--------
      RETURN
      END
C INIVAL SUBROUTINE
C ------ ----------
C This subroutine generates the statements which initialize the indepen-
C  dent variables and shift the initial conditions given in the input.
C***************
      SUBROUTINE INIVAL(MDIFFP,DCONS,MINDV,INOUT,MND,MVAR,MEQU)
C***************
      DIMENSION DCONS(1),INOUT(1),MVAR(1),MEQU(1),MINDV(1),MND(1),
     A MIP(18)
      DOUBLE PRECISION DCONS
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      SAVE MIP
      DATA MIP/44,45,19,20,1,18,20,49,6*45,44,45,8,50/
      NVAR3 = NVARS*2
      MEQUS = NEQUS
      MSPACE = NSPACE
C--------
      MTEMP6 = INOUTP
      DO 2305 MMT=1,MEQUS
      MNT = MMT + MEQUS
C Zero means the search is over.
      IF(MINDV(MNT) .EQ. 0) GO TO  2306
C Skip negatives.
      IF(MINDV(MNT) .LT. 0) GO TO  2305
      MTEMP1 = MMT
 2301 MTEMP1 = MTEMP1 + 1
      MTP = MTEMP1 + MEQUS
      IF(MINDV(MTP) .EQ. MINDV(MNT)) MINDV(MTP) = -1
      IF(MINDV(MTP) .NE. 0) GO TO 2301
      DO 2302 MTEMP1=1,6
 2302 INOUT(MTEMP1) = 45
      INOUTP = 7
      MTEMP1 = MINDV(MNT)
      MTEMP1 = MTEMP1 + MAXSIZ
      CALL OTRANS(MTEMP1,1,0,0,DCONS,INOUT,MND,MVAR)
      INOUTP = INOUTP - 1
      DO 2303 MTEMP3=1,14
      MTEMP4 = INOUTP + MTEMP3
 2303 INOUT(MTEMP4) = MIP(MTEMP3)
      INOUTP = MTEMP4 + 1
      CALL OTRANS(MTEMP1,2,0,0,DCONS,INOUT,MND,MVAR)
      DO 2304 MTEMP3=15,18
      INOUT(INOUTP) = MIP(MTEMP3)
 2304 INOUTP = INOUTP + 1
      CALL OUTLIN(INOUT,IOOBJE)
 2305 CONTINUE
 2306 CONTINUE
C--------
C This section shifts the initial values by the H and factorial
C  elements of the Taylor series terms.
C--------
      DO 2309 MMT=1,MDIFFP
      MTEMP1 = MEQU(MMT+NVARS)
      MTEMP2 = MEQU(MMT+NVAR3) - 1
      IF(MTEMP2.LT.1 .OR. MTEMP2.GT.7) GO TO 2309
      MTEMP1 = MTEMP1 + MAXSIZ
      DO 2308 M2=1,MTEMP2
      DO 2307 INOUTP=1,MSPACE
 2307 INOUT(INOUTP) = 45
      INOUTP = MSPACE + 1
      CALL OTRANS(MTEMP1,1,M2,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP) = 44
      INOUT(INOUTP+1) = 45
      INOUTP = INOUTP + 2
      CALL OTRANS(MTEMP1,1,M2,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP-1) = 39
      MTEMP3 = 3*MAXSIZ + M2
      CALL OTRANS(MTEMP3,1,0,0,DCONS,INOUT,MND,MVAR)
      INOUT(INOUTP) = 50
      CALL OUTLIN(INOUT,IOOBJE)
 2308 CONTINUE
 2309 CONTINUE
      INOUTP = MTEMP6
      RETURN
C--------
C end INIVAL
C--------
      END
C NDXSHF SUBROUTINE
C ------ ----------
C This subroutine generates KA'S, KB'S, etc. and the shift variables.
C***************
      SUBROUTINE NDXSHF(LOOPNX)
C***************
      DIMENSION MAUX(17)
      COMMON /IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      SAVE MAUX
      DATA MAUX/6*45,11,2*45,44,45,11,45,38,2*45,50/
      MAXAUX = 2 + LOOPNX
      ITOP = MAXAUX
      IF(ITOP.GT.9) ITOP = 9
      DO 2401 INDEX=1,ITOP
      MAUX(8) = INDEX
      MAUX(16) = INDEX + 27
      CALL OUTLIN(MAUX,IOOBJE)
 2401 CONTINUE
      IF(MAXAUX.LT.10) GO TO 2403
      MAUX(13) = 9
      DO 2402 INDEX=10,MAXAUX
      JNDEX = INDEX - 9
      MAUX(8) = INDEX
      MAUX(16) = JNDEX + 27
      CALL OUTLIN(MAUX,IOOBJE)
 2402 CONTINUE
C--------
C end NDXSHF
C--------
 2403 RETURN
      END
C ATSATT SUBROUTINE
C ------ ----------
C This subroutine places into the output array (INOUT) the code for
C  either the 'ATS' or 'ATT' subroutines.
C***************
      SUBROUTINE ATSATT(NOFFST,LSTART,NDX,NDXFLG,NSOURC,NSIZE,NSTRT,
     A DCONS,MTRPL,INOUT,MND,MVAR)
C***************
      DIMENSION DCONS(1),MTRPL(1),INOUT(1),MVAR(1),NSOURC(NSIZE),MND(1)
      DOUBLE PRECISION DCONS
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
     E /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
      NVAR3 = NVARS*2
C--------
C This driver loop transfers the characters from the source array to the
C  output array.  If the byte is negative, an exit handler is called.
C--------
      MTEMP1 = NSIZE - 1
      NEND = NSIZE - 2
      NSTART = NSTRT
 2501 DO 2502 N=NSTART,NEND
      IF(NSOURC(N).LT.0) GO TO 2503
      INOUT(INOUTP) = NSOURC(N)
      INOUTP = INOUTP + 1
 2502 CONTINUE
      RETURN
C--------
C The exit handler saves the location of the next character, and jumps
C  to the correct exit procedure.
C--------
 2503 NSTART = N + 1
      JUMP = - NSOURC(N)
      GO TO (2504,2505,2507,2511,2512,2513,2513,2514,2517,2518,2510,
     A 2519,2521,2524,2525,2527,2511), JUMP
C--------
C  EXIT 1.  This section tests the two values in the last elements of
C  the source array to see if the statements KZ=.. or KY=.. are needed.
C--------
 2504 ND2 = NDX - NOFFST
      IF(KFNCT.EQ.2) GO TO 2501
      IF(NSOURC(MTEMP1).EQ.ND2 .AND. NSOURC(NSIZE).EQ.NDXFLG) NSTART=18
      NSOURC(MTEMP1) = ND2
      NSOURC(NSIZE) = NDXFLG
      GO TO 2501
C--------
C EXIT 2.  This inserts a number of spaces at the beginning of a line.
C--------
 2505 N2 = INOUTP
      INOUTP = INOUTP + NSPACE
      DO 2506 N3=N2,INOUTP
 2506 INOUT(N3) = 45
      GO TO 2501
C--------
C  EXIT 3.  This inserts the terminating constant value for the DO-loop.
C--------
 2507 IF(NDXFLG.EQ.1) GO TO 2510
      N2 = NDX + NOFFST
      IF(N2.EQ.0) GO TO 2501
      IF(N2.LT.100) GO TO 2508
      N1 = N2/100
      INOUT(INOUTP) = N1 + 27
      INOUTP = INOUTP + 1
      N2 = N2 - N1*100
 2508 N3 = N2/10
      IF(N3.EQ.0) GO TO 2509
      INOUT(INOUTP) = N3 + 27
      INOUTP = INOUTP + 1
 2509 INOUT(INOUTP) = N2 - N3*10 + 27
      INOUTP = INOUTP + 1
      GO TO 2501
C--------
C  EXIT 11.  This inserts a terminating variable value for the DO-loop.
C--------
 2510 INOUT(INOUTP) = 11
      INOUTP = INOUTP + 1
      N2 = NDX + NOFFST
      IF(N2.LE.0) GO TO 2501
      INOUT(INOUTP) = N2
      INOUTP = INOUTP + 1
      GO TO 2501
C--------
C  EXIT 4.  This inserts the proper statement label into the program.
C--------
 2511 MTEMP3 = NSTMT
      MTEMP1 = MTEMP3/1000
      INOUT(INOUTP) = MTEMP1 + 27
      INOUTP = INOUTP + 1
      MTEMP3 = MTEMP3 - MTEMP1*1000
      MTEMP1 = MTEMP3/100
      INOUT(INOUTP) = MTEMP1 + 27
      INOUTP = INOUTP + 1
      MTEMP1 = MTEMP3 - MTEMP1*100
      MTEMP2 = MTEMP1/10
      MTEMP1 = MTEMP1 - MTEMP2*10
      INOUT(INOUTP) = MTEMP2 + 27
      INOUT(INOUTP+1) = MTEMP1 + 27
      INOUTP = INOUTP + 2
      IF(JUMP.GT.4) NSTMT = NSTMT + 1
      GO TO 2501
C--------
C  EXIT 5.  This inserts the initial value of the DO-loop index.
C--------
 2512 INOUT(INOUTP) = LSTART + 27
      INOUTP = INOUTP + 1
      GO TO 2501
C--------
C  EXIT 6.  This generates the characters for 'variable ='.
C--------
C  EXIT 7. Same as above without backspacing (INOUT-5).
C--------
 2513 MTEMP1 = MTRPL(LAST+NOPS)
      CALL OTRANS(MTEMP1,NDX,0,NDXFLG,DCONS,INOUT,MND,MVAR)
      GO TO 2501
C--------
C EXIT 8.  This transfers the characters for the variable which is on
C  the left of the operator.
C--------
 2514 N2 = 2
 2515 MTP = INPTR + NOPS*(N2 - 1)
      N3 = MTRPL(MTP)
      MTEMP2 = N3 - MAXSIZ
      IF(MND(MTEMP2).GE.NDX .OR. NDXFLG.EQ.1) GO TO 2516
      KDELAY = 1
      RETURN
 2516 NSAVE = MVAR(MTEMP2+NVAR3)
      MVAR(MTEMP2+NVAR3) = 1
      CALL OTRANS(N3,1,0,0,DCONS,INOUT,MND,MVAR)
      MVAR(MTEMP2+NVAR3) = NSAVE
      INOUTP = INOUTP - 1
      GO TO 2501
C--------
C EXIT 9.  This transfers the characters for the variable which appears
C  on the right of the operator.
C--------
 2517 N2 = 3
      GO TO 2515
C--------
C EXIT 10.  This inserts the constant divisor required by ATT.
C--------
 2518 IF(NDXFLG.EQ.1) GO TO 2501
      NSTART = NEND
      INOUT(INOUTP) = 27 + NDX - NOFFST
      INOUT(INOUTP+1) = 47
      INOUT(INOUTP+2) = 5 - KDOBLE
      INOUT(INOUTP+3) = 27
      INOUTP = INOUTP + 4
      GO TO 2501
C--------
C EXIT 12.  This is to place either an E or a D, as needed.
C--------
 2519 IF(KDOBLE.EQ.0) GO TO 2520
      INOUT(INOUTP) = 4
      INOUTP = INOUTP + 1
      GO TO 2501
 2520 INOUT(INOUTP) = 5
      INOUTP = INOUTP + 1
      GO TO 2501
C--------
C EXIT 13.  This to add a D or a CD when needed.
C--------
 2521 IF(KDOBLE.EQ.0) GO TO 2523
      IF(KOMPLX.EQ.0) GO TO 2522
      INOUT(INOUTP) = 3
      INOUTP = INOUTP + 1
 2522 INOUT(INOUTP) = 4
      INOUTP = INOUTP + 1
      GO TO 2501
 2523 IF(KOMPLX.EQ.0) GO TO 2501
      INOUT(INOUTP) = 3
      INOUTP = INOUTP + 1
      GO TO 2501
C--------
C EXIT 14.  To generate the shift being processed in the DO-loops.
C--------
 2524 INOUT(INOUTP) = 19
      INOUT(INOUTP+1) = 8
      INOUT(INOUTP+2) = 9
      INOUT(INOUTP+3) = 6
      INOUT(INOUTP+4) = 20
      INOUT(INOUTP+5) = 45
      INOUTP = INOUTP + 6
      GO TO 2501
C--------
C EXIT 15.  To generate CZRO for complex instead of 0.E0
C--------
 2525 IF(KOMPLX.EQ.1) GO TO 2526
      INOUT(INOUTP) = 27
      INOUTP = INOUTP + 1
      GO TO 2501
 2526 INOUT(INOUTP-3) = 3
      INOUT(INOUTP-2) = 26
      INOUT(INOUTP-1) = 18
      INOUT(INOUTP) = 15
      INOUTP = INOUTP + 1
      GO TO 2501
C--------
C EXIT 16.  TO add a Z
C--------
 2527 INOUT(INOUTP) = 26
      INOUTP = INOUTP + 1
      GO TO 2501
C--------
C end ATSATT
C--------
      END
C MTERM SUBROUTINE
C ----- ----------
C This subroutine places two operands and an operator into 'INOUT'.
C***************
      SUBROUTINE MTERM(PTR1,NDX1,NDXD1,NDXF1,PTR2,NDX2,NDXD2,NDXF2,NOP,
     A DCONS,INOUT,MND,MVAR)
C***************
      DIMENSION DCONS(1),INOUT(1),MVAR(1),MND(1)
      DOUBLE PRECISION DCONS
      INTEGER PTR1,PTR2
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON /POINTR/NSPACE,NSTMT,INPTR,LAST,INOUTP,LRIGHT,KDELAY
      CALL OTRANS(PTR1,NDX1,NDXD1,NDXF1,DCONS,INOUT,MND,MVAR)
      IF(NOP.EQ.39 .OR. NOP.EQ.40) GO TO 2601
      INOUT(INOUTP) = NOP
      INOUT(INOUTP+1) = 45
      INOUTP = INOUTP + 2
      GO TO 2602
 2601 INOUT(INOUTP-1) = NOP
 2602 CALL OTRANS(PTR2,NDX2,NDXD2,NDXF2,DCONS,INOUT,MND,MVAR)
C--------
C end MTERM
C--------
      RETURN
      END
C ORDER SUBROUTINE
C ------ ----------
C This subroutine searches for the cnditn triplet, and moves it up.
C***************
      SUBROUTINE ORDER(KEY,MREQUP,MTRPL,INOUT,MVAR,MND,MEQU)
C***************
      DIMENSION MTRPL(1),INOUT(1),MVAR(1),MND(2),MEQU(1),NTOP(9),
     A JBOT(9),NCNDA(45)
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
     E /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      DATA NAME,ITN,IT0/5364,15214,15227/
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      IF(KEY.EQ.2) GO TO 2754
C Clear the MND and MSTK arrays.
      DO 2701 K=1,NVARS
 2701 MND(K) = 0
      DO 2702 K=1,200
 2702 MSTK(K) = 0
      MND(2) = NCARD
      MNDP = 0
C Order the equations as their relational distances from CNDITN.
      DO 2704 K=1,MREQUP
      MTK = MREQUP + 1 - K
      MTRPLP = MEQU(MTK)
C Search the equation list backwards for a triplet with a variable.
      MTEMP1 = MTRPL(MTRPLP+NOPS) - MAXSIZ
C MTEMP1 is the pointer to the variable.
      IF(MTEMP1.LT.0 .OR. MTEMP1.GT.MAXSIZ) GO TO 2704
C If that variable has not yet been set up, skip the equation.
C CNDITN is the only one set up initially.
      IF(MND(MTEMP1).EQ.0) GO TO 2704
C Examine the second operand.  Is it a variable?
      MTEMP2 = MTRPL(MTRPLP+NOP3) - MAXSIZ
C Set the second operand's MND to 1, if it is a variable.
      IF(MTEMP2.GT.0 .AND. MTEMP2.LT.MAXSIZ) MND(MTEMP2) = 1
      MNDP = MNDP + 1
C Increment and store the MTK pointer.
      MND(MNDP+NVARS) = MTK
      DO 2703 KK=1,MTRPLP
C Look backwards through all the triplets from the current point.
      MBACK = MTRPLP - KK
C Skip if an =.
      IF(MBACK.EQ.0 .OR. MTRPL(MBACK).EQ.44) GO TO 2704
      MTEMP1 = MTRPL(MBACK+NOPS) - MAXSIZ
      IF(MTEMP1.GT.0 .AND. MTEMP1.LT.MAXSIZ) MND(MTEMP1) = 1
C Set the first operand's MND to 1, if it is a variable.
      MTEMP2 = MTRPL(MBACK+NOP3) - MAXSIZ
      IF(MTEMP2.GT.0 .AND. MTEMP2.LT.MAXSIZ) MND(MTEMP2) = 1
 2703 CONTINUE
 2704 CONTINUE
      MNDPS = MNDP + 1
C Re-arrange the equations and place into the MND array.
      DO 2705 K=1,MNDP
      KBT = MNDPS - K
      MTEMP1 = MND(KBT+NVARS)
      MND(K) = MEQU(MTEMP1)
 2705 MEQU(MTEMP1) = 0
C Pack in the left over equations.
      DO 2706 K=1,MREQUP
      MTEMP1 = MEQU(K)
      IF(MTEMP1.EQ.0) GO TO 2706
      MNDP = MNDP + 1
      MND(MNDP) = MTEMP1
 2706 CONTINUE
C Unpack back into the MEQU array.
      DO 2707 K=1,MNDP
 2707 MEQU(K) = MND(K)
      IF(NCARD.LT.2) GO TO 2754
C--------
C Search for the DIFF's.
C--------
C Clear the hashing array.
      DO 2708 J=1,NVARS
 2708 INOUT(NVARS+J) = 0
      KTDIF = 0
      DO 2709 K=1,MREQUP
      MTRPLP = MEQU(K)
      MTEMP1 = MTRPL(MTRPLP+NOPS)
C All DIFF equations have an address as its first operand.
      IF(MTEMP1.GT.MAXSIZ) GO TO 2709
      MTEMP2 = MTRPL(MTEMP1)
C Double check that it is DIFF.
      IF(MTEMP2.NE.14) GO TO 2709
C Store the order in the dependent variable's name location.
      KTDIF = KTDIF + 1
      LOCATE = MTRPL(MTEMP1+NOPS) - MAXSIZ
      INOUT(NVARS+LOCATE) = KTDIF*10
 2709 CONTINUE
C--------
C Search for the CND's.
C--------
      KOUNT = 0
      DO 2712 K=1,MREQUP
      MTRPLP = MEQU(K)
      MTEMP1 = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MTEMP1.LT.0 .OR. MTEMP1.GT.MAXSIZ) GO TO 2712
      MTEMP2 = MVAR(MTEMP1)
C..Does the variable name start with CND?
      IF(MTEMP2.NE.NAME) GO TO 2712
      MTEMP3 = MVAR(MTEMP1+NVARS)
C..Does the variable name ends with ITN?
      IF(MTEMP3.EQ.ITN) GO TO 2710
C..This is the cardinal.
      MTEMP3 = MTEMP3 - IT0
      GO TO 2711
 2710 MTEMP3 = 1
C Set up the variable name.
 2711 INOUT(MTEMP3+NOP4) = MTEMP1
C Point to the CND equation.
      INOUT(MTEMP3+NOP4+10) = MTRPLP
C Point to the MEQU stack.
      INOUT(MTEMP3+NOP4+20) = K
      KOUNT = KOUNT + 1
C This will work for NCARD=1.
      IF(KOUNT.EQ.NCARD) GO TO 2713
 2712 CONTINUE
 2713 DO 2732 NN=1,NCARD
C Clear the storing bins.
      DO 2714 J=1,100
 2714 INOUT(J) = 0
C Clear the hashing array, while saving the dependent variables.
      DO 2715 J=1,NVARS
      IF(INOUT(NVARS+J).LT.10) INOUT(NVARS+J) = 0
 2715 CONTINUE
C Work with the CND's forwards.
      K = INOUT(NN+NOP4+20)
      MTRPLP = INOUT(NN+NOP4+10)
      MTEMP1 = INOUT(NN+NOP4)
C Hash the CND.
      INOUT(NVARS+MTEMP1) = 1
C Perform a sweep of the triplets to find all the parents.
      DO 2719 J=1,MTRPLP
      MTEMP5 = MTRPLP - J
C Stop when the previous equation is reached.
      IF(MTRPL(MTEMP5).EQ.44) GO TO 2720
      MTEMP1 = MTRPL(MTEMP5+NOPS) - MAXSIZ
      IF(MTEMP1.LT.0 .OR. MTEMP1.GT.MAXSIZ) GO TO 2717
C The first operand is a variable.  Is it a DIFF?
      IF(INOUT(NVARS+MTEMP1).LT.2) GO TO 2716
      KPTR = (1 + INOUT(NVARS+MTEMP1))/10
C Raise the flag in the storing bin.
      INOUT(KPTR) = 1
      GO TO 2717
C Hash it.
 2716 INOUT(NVARS+MTEMP1) = 1
 2717 MTEMP2 = MTRPL(MTEMP5+NOP3) - MAXSIZ
      IF(MTEMP2.LT.0 .OR. MTEMP2.GT.MAXSIZ) GO TO 2719
C The second operand is a variable.  Is it a DIFF?
      IF(INOUT(NVARS+MTEMP2).LT.2) GO TO 2718
      KPTR = (1 + INOUT(NVARS+MTEMP2))/10
C Raise the flag in the storing bin.
      INOUT(KPTR) = 1
      GO TO 2719
C Hash it.
 2718 INOUT(NVARS+MTEMP2) = 1
 2719 CONTINUE
C Sweep all the equations backwards to find all the grandparents.
 2720 DO 2729 J=1,MREQUP
      KJ = MREQUP + 1 - J
C Avoid the current CND
      IF(KJ.EQ.K) GO TO 2729
      MTEMP5 = MEQU(KJ)
      MTEMP1 = MTRPL(MTEMP5+NOPS) - MAXSIZ
      IF(MTEMP1.LT.0 .OR. MTEMP1.GT.MAXSIZ) GO TO 2729
C The first operand is a variable.
      IF(INOUT(NVARS+MTEMP1).EQ.0) GO TO 2729
C It is a parent variable.
C Look for its parents.  This a tracking of the branches.
      MTEMP4 = MTRPL(MTEMP5+NOP3)
C This has to be an address, but check anyhow.
      IF(MTEMP4.GT.MAXSIZ) GO TO 2729
C Searching all the branches.
      MSTKP = 0
      DO 2728 L=1,50000
C First operand.
      MTEMP1 = MTRPL(MTEMP4+NOPS) - MAXSIZ
      MTEMP3 = 0
C Do not process a constant.
      IF(MTEMP1.GT.MAXSIZ) GO TO 2722
C Flip flag for an address.
      IF(MTEMP1.LT.0) MTEMP3 = 1
C This is a variable.  Is it a DIFF?
      IF(INOUT(NVARS+MTEMP1).LT.2) GO TO 2721
      KPTR = (1 + INOUT(NVARS+MTEMP1))/10
C Raise the flag in the storing bin.
      INOUT(KPTR) = 1
      GO TO 2722
C Raise its flag in the hash array.
 2721 INOUT(NVARS+MTEMP1) = 1
C Second operand
 2722 MTEMP2 = MTRPL(MTEMP4+NOP3) - MAXSIZ
      MTEMP5 = 0
      IF(MTEMP2.GT.MAXSIZ) GO TO 2724
      IF(MTEMP2.LT.0) MTEMP5 = 1
C This is a variable,  Is it a DIFF?
      IF(INOUT(NVARS+MTEMP2).LT.2) GO TO 2723
      KPTR = (1 + INOUT(NVARS+MTEMP2))/10
C Raise the flag in the storing bin.
      INOUT(KPTR) = 1
      GO TO 2724
C Raise its flag in the hash array.
 2723 INOUT(NVARS+MTEMP2) = 1
C We are done with this level if both branches are variables.
 2724 IF(MTEMP3.EQ.0 .AND. MTEMP5.EQ.0) GO TO 2727
C Save the address for a later search.
      IF(MTEMP3.EQ.1 .AND. MTEMP5.EQ.1) GO TO 2725
      IF(MTEMP5.EQ.1) GO TO 2726
      MTEMP4 = MTEMP3
      GO TO 2728
 2725 MSTKP = MSTKP + 1
      MSTK(MSTKP) = MTEMP3
 2726 MTEMP4 = MTEMP5
      GO TO 2728
C Check the stack.
 2727 IF(MSTKP.EQ.0) GO TO 2729
      MTEMP4 = MSTK(MSTKP)
      MSTKP = MSTKP - 1
 2728 CONTINUE
 2729 CONTINUE
C Check the storing bin for the dependent variables.
      NCND = 0
      DO 2730 J=1,100
      IF(INOUT(J).EQ.0) GO TO 2730
      NCND = NCND + 1
C Use 20 bins per CND, internally.
      LOAD = NCND + (NN - 1)*20
      MSTK(LOAD) = J
 2730 CONTINUE
      IF(NCND.GT.0) GO TO 2732
C At least one dependent variable must be a parent of a CND.
      WRITE(*,2731)
 2731 FORMAT(' ***************** ATOMFT is stopped. *******************'
     A/'  In a DAE problem, each algebraic equation must refer,'/
     B '              directly or indirectly,'/
     C '         to at least one dependent variable.'/
     D ' ***************** ATOMFT is stopped. *******************')
      STOP
 2732 CONTINUE
C Analyze the CND bins.
      DO 2735 NN=1,NCARD
      NBOT = (NN - 1)*20
C Locate the top bins.
      DO 2733 I=1,20
      IZ = 21 - I
      LOAD = IZ + NBOT
      IF(MSTK(LOAD).GT.0) GO TO 2734
 2733 CONTINUE
 2734 NTOP(NN) = LOAD
C Store the top ODE for analysis.
      NCNDA(NN) = MSTK(LOAD)
 2735 CONTINUE
C Check the monotonic sequence.
      DO 2736 NN=2,NCARD
      IF(NCNDA(NN) .LE. NCNDA(NN-1)) GO TO 2737
 2736 CONTINUE
      NBAD = 0
C Everything is ok, proceed.
      GO TO 2740
 2737 NBAD = NN
C Print error message.
      WRITE(IOOBJE,2738)
 2738 FORMAT('C******************************************************'/
     A 'C Multi-constraint DAE problems must have their ODE and'/
     B 'C   algebraic CND equations stated in a logical order.'/
     C 'C Or else, the ATSPGM program will have iteration loops'/
     D 'C   that do not contain all the necessary functions.'/'C'/
     E 'C If you are willing and able to edit ATSPGM to correct'/
     F 'C   the logical errors, proceed ahead.'/
     G 'C******************************************************')
      WRITE(*,2739)NBAD
 2739 FORMAT(' ********************************************************'
     A/' ATOMFT cannot process this multi-constraint DAE properly,'/
     B '    because CND',i1,' is out of position.'/
     C ' In the listing below, the ODE numbers must be in ascending'/
     D '    order, and they must be evenly distributed.'//
     E ' Re-order the algebraic equations if unascending ODE.'/
     F ' Re-order the ODEs if unevenly distributed.'/)
 2740 DO 2741 J=1,45
 2741 NCNDA(J) = 0
C Pack down the bins.
      KOUNT = 0
      DO 2747 NN=1,NCARD
      NBOT = (NN - 1)*20 + 1
      LOAD = NTOP(NN)
      IF(NN.EQ.1) GO TO 2745
C Skip the previously used ODE's.
      DO 2743 J=NBOT,LOAD
      MATCH = MSTK(J)
      DO 2742 JJ=1,KOUNT
      IF(MATCH.EQ.NCNDA(JJ)) GO TO 2743
 2742 CONTINUE
      GO TO 2744
 2743 CONTINUE
      JBOT(NN) = LOAD
      GO TO 2747
 2744 NBOT = J
      JBOT(NN) = NBOT
 2745 DO 2746 JJ=NBOT,LOAD
      KOUNT = KOUNT + 1
 2746 NCNDA(KOUNT) = MSTK(JJ)
 2747 CONTINUE
C Re-load the MSTK bins.
      JBOT(1) = 1
      DO 2750 NN=1,NCARD
      KOUNT = 0
      NEWBOT = (NN - 1)*5
      NBOT = JBOT(NN)
      LOAD = NTOP(NN)
      DO 2748 JJ=NBOT,LOAD
      KOUNT = KOUNT + 1
      IF(KOUNT.EQ.6) GO TO 2750
      MSTK(NEWBOT+KOUNT) = MSTK(JJ)
 2748 NTOP(NN) = NEWBOT + KOUNT
      JJBOT = KOUNT + 1
      DO 2749 JJ=JJBOT,5
      KOUNT = KOUNT + 1
 2749 MSTK(NEWBOT+KOUNT) = 0
 2750 CONTINUE
      IF(NBAD.EQ.0) GO TO 2754
      DO 2752 NN=1,NCARD
      KK = NCARD + 1 - NN
C Print the CND bins in full.
      NBOT = (KK - 1)*5 + 1
      LOAD = NTOP(KK)
      WRITE(*,2751)KK,(MSTK(II),II=NBOT,LOAD)
 2751 FORMAT(' CND',I1,' uses ODE',5I4)
 2752 CONTINUE
      WRITE(*,2753)
 2753 FORMAT(' *******************************************************')
 2754 DO 2755 K=1,NVARS
 2755 MND(K) = 0
      MXSIZ = MAXSIZ/10
C Search for the derivative orders for each dependent variable.
      DO 2756 K=1,MREQUP
      MTRPLP = MEQU(K)
      MTEMP2 = MTRPL(MTRPLP+NOPS)
      IF(MTEMP2.GT.MAXSIZ) GO TO 2756
      MTEMP4 = MTRPL(MTEMP2)
      IF(MTEMP4.NE.14) GO TO 2756
      MTEMP4 = MTRPL(MTEMP2+NOPS) - MAXSIZ
      MTEMP3 = MTRPL(MTEMP2+NOP3)/MXSIZ
      MTEMP1 = MTRPL(MTEMP2+NOP3) - MTEMP3*MXSIZ
      MTEMP3 = MTEMP3 - 10
      IF(MTEMP3.EQ.9) MTEMP3 = 0
C Set the derivative order into MND.
      MND(MTEMP4) = MTEMP3
      MND(MTEMP1) = 2
 2756 CONTINUE
C--------
C end of ORDER
C--------
      RETURN
      END
C ORDDAE SUBROUTINE
C ------ ----------
C This subroutine orders the equation pointers for a multiple DAE.
C***************
      SUBROUTINE ORDDAE(KEY,MREQUP,MTRPL,INOUT,MVAR,MEQU)
C***************
      DIMENSION MTRPL(1),INOUT(2),MVAR(1),MEQU(1),JEQU(1000),MTR(1000)
      COMMON/SIZE/NEQUS,NVARS,NOPS,MSTK(200)
      COMMON/IOUNIT/IOINPU,IOLIST,IOOBJE,MAXSIZ,NTYP2
     E /ATSOPT/KDUMP,LENVAR,KDOBLE,KOMPLX,KFNCT,NCARD
      SAVE NAME,ITN,IT0,NAMEFT,NCN0,LINEQU
      DATA NAME,ITN,IT0,NAMEFT,NCN0/5364,15214,15227,10180,5387/
      NOP3 = NOPS*2
      NOP4 = NOPS*3
      IF(KEY.EQ.2) GO TO 2816
      JEQUP = 0
C--------
C Point to the DIFF's.
C--------
      DO 2801 MEQUP=1,MREQUP
      MTRPLP = MEQU(MEQUP)
      MTEMP2 = MTRPL(MTRPLP+NOPS)
      IF(MTEMP2.GT.MAXSIZ) GO TO 2801
      MTEMP3 = MTRPL(MTEMP2)
      IF(MTEMP3.NE.14) GO TO 2801
      JEQUP = JEQUP + 1
      MTR(JEQUP) = MTRPLP
      JEQU(JEQUP) = MEQUP
 2801 CONTINUE
C Search backwards for the end of the equations in MTRPL.
      MAXMTR = 1
      DO 2802 K=1,MREQUP
      MTRPLP = MEQU(K)
 2802 MAXMTR = MAX0(MTRPLP,MAXMTR)
      DO 2803 K=1,MAXMTR
      MTEMP1 = MTRPL(MAXMTR-K)
      IF(MTEMP1.EQ.0 .OR. MTEMP1.EQ.44) GO TO 2803
      GO TO 2804
 2803 CONTINUE
 2804 KBOT = MAXMTR - K
      DO 2805 K=KBOT,NOPS
      MTEMP1 = MTRPL(K)
      IF(MTEMP1.EQ.44) GO TO 2806
 2805 CONTINUE
 2806 LINEQU = K
      KTOP = JEQUP - 1
      DO 2815 K=1,KTOP
      KMTR = MTR(K)
      KBOT = K + 1
      DO 2807 KK=KBOT,JEQUP
      LMTR = MTR(KK)
      IF(LMTR.LT.KMTR) GO TO 2808
 2807 CONTINUE
      GO TO 2815
 2808 LEQU = JEQU(KK)
C There is an equation out of order.
      INOUT(1) = JEQU(KK)
      INOUT(2) = MTR(KK)
      KEQU = JEQU(K-1)
      DO 2809 KK=1,1000
      KJ = LEQU - KK
      IF(MEQU(KJ).LE.LINEQU) GO TO 2810
 2809 CONTINUE
 2810 KJ = KJ + 1
      KPOINT = 0
      DO 2811 KK=KJ,LEQU
      KPOINT = KPOINT + 1
 2811 INOUT(KPOINT+10) = MEQU(KK)
      KTOP = JEQUP - 1
      KZ = JEQUP + 1
      DO 2812 KK=KBOT,KTOP
      KZ = KZ - 1
      JEQU(KZ) = JEQU(KZ-1)
 2812 MTR(KZ) = MTR(KZ-1)
      JEQU(KBOT) = INOUT(1)
      MTR(KBOT) = INOUT(2)
      KTOP = MREQUP - KPOINT
      KZ = MREQUP + 1
      DO 2813 KK=KBOT,KTOP
      KZ = KZ - 1
 2813 MEQU(KZ) = MEQU(KZ-KPOINT)
      DO 2814 KK=1,KPOINT
      LMTR = LMTR + 1
 2814 MEQU(LMTR) = INOUT(KK+10)
 2815 CONTINUE
      RETURN
 2816 MEQDIF = 0
C--------
C Point to the first DIFF.
C--------
      DO 2817 MEQUP=1,MREQUP
      MTRPLP = MEQU(MEQUP)
      MTEMP2 = MTRPL(MTRPLP+NOPS)
      IF(MTEMP2.GT.MAXSIZ) GO TO 2817
      MTEMP3 = MTRPL(MTEMP2)
      IF(MTEMP3.NE.14) GO TO 2817
      IF(MEQDIF.EQ.0) MEQDIF = MEQUP
 2817 CONTINUE
      MEQDIF = MEQDIF - 1
C--------
C Search for the CND's.
C--------
      KOUNT = 0
      DO 2820 K=1,MREQUP
      MTRPLP = MEQU(K)
      MTEMP1 = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MTEMP1.LT.0 .OR. MTEMP1.GT.MAXSIZ) GO TO 2820
      MTEMP2 = MVAR(MTEMP1)
C..Does the variable name start with CND?
      IF(MTEMP2.NE.NAME) GO TO 2820
      MTEMP3 = MVAR(MTEMP1+NVARS)
C..Does the variable name ends with ITN?
      IF(MTEMP3.EQ.ITN) GO TO 2818
      MTEMP3 = MTEMP3 - IT0
C..This is the cardinal.
      INOUT(MTEMP3) = MTEMP1
      GO TO 2819
 2818 INOUT(1) = MTEMP1
 2819 KOUNT = KOUNT + 1
      IF(KOUNT.EQ.NCARD) GO TO 2821
 2820 CONTINUE
 2821 DO 2832 NN=1,NCARD
      MTEMP1 = INOUT(NCARD+1-NN)
      DO 2822 K=1,NVARS
 2822 INOUT(2000+K) = 0
      INOUT(2000+MTEMP1) = 1
      MNDP = 0
      DO 2827 K=1,MREQUP
      MTK = MREQUP + 1 - K
      MTRPLP = MEQU(MTK)
      MTEMP1 = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MTEMP1.GT.0) GO TO 2823
      MTEMP1 = MTEMP1 + MAXSIZ
      MTEMP2 = MTRPL(MTEMP1)
      IF(MTEMP2.NE.14) GO TO 2827
      MTEMP1 = MTRPL(MTEMP1+NOPS) - MAXSIZ
      IF(INOUT(2000+MTEMP1).EQ.0) GO TO 2827
      MNDP = MNDP + 1
      INOUT(2000+MNDP+NVARS) = MTK
      GO TO 2827
 2823 IF(MTEMP1.LT.0 .OR. MTEMP1.GT.MAXSIZ) GO TO 2827
      IF(INOUT(2000+MTEMP1).EQ.0) GO TO 2827
      MTEMP2 = MTRPL(MTRPLP+NOP3) - MAXSIZ
      IF(MTEMP2.LT.0 .OR. MTEMP2.GT.MAXSIZ) GO TO 2824
      MTEMP3 = MTRPL(MTRPLP+NOP4)
      NTYPE1 = MTEMP3/16
      MTEMP3 = MTEMP3 - NTYPE1*16
      NTYPE2 = MTEMP3/4
      NTYPE3 = MTEMP3 - NTYPE2*4
      IF(NTYPE3.GT.1) INOUT(2000+MTEMP2) = 1
 2824 MNDP = MNDP + 1
      INOUT(2000+MNDP+NVARS) = MTK
C Do not process single line equations with zero.
      IF(MTRPLP.GT.LINEQU) GO TO 2827
      DO 2826 KK=1,MTRPLP
      MBACK = MTRPLP - KK
      IF(MBACK.EQ.0 .OR. MTRPL(MBACK).EQ.44) GO TO 2827
      MTEMP3 = MTRPL(MBACK+NOP4)
      NTYPE1 = MTEMP3/16
      MTEMP3 = MTEMP3 - NTYPE1*16
      NTYPE2 = MTEMP3/4
      NTYPE3 = MTEMP3 - NTYPE2*4
      MTEMP1 = MTRPL(MBACK+NOPS) - MAXSIZ
      IF(MTEMP1.LT.0 .OR. MTEMP1.GT.MAXSIZ) GO TO 2825
      IF(NTYPE2.GT.1) INOUT(2000+MTEMP1) = 1
 2825 MTEMP2 = MTRPL(MBACK+NOP3) - MAXSIZ
      IF(MTEMP2.LT.0 .OR. MTEMP2.GT.MAXSIZ) GO TO 2826
      IF(NTYPE3.GT.1) INOUT(2000+MTEMP2) = 1
 2826 CONTINUE
 2827 CONTINUE
      DO 2828 K=1,MEQDIF
      INOUT(2000+K) = MEQU(K)
 2828 MEQU(K) = 0
      MNDPS = MNDP + 1
      DO 2829 K=1,MNDP
      KBT = MNDPS - K
      MTEMP1 = INOUT(2000+KBT+NVARS)
      INOUT(2000+K+MEQDIF) = MEQU(MTEMP1)
 2829 MEQU(MTEMP1) = 0
      DO 2830 K=1,MREQUP
      MTEMP1 = MEQU(K)
      IF(MTEMP1.EQ.0) GO TO 2830
      MNDP = MNDP + 1
      INOUT(2000+MNDP+MEQDIF) = MTEMP1
 2830 CONTINUE
      DO 2831 K=1,MREQUP
 2831 MEQU(K) = INOUT(2000+K)
 2832 CONTINUE
C--------
C Locate all variables in the equations.  Store in INOUT at 2000+.
C--------
      DO 2833 MEQUP=1,MREQUP
      INOUT(2000+MEQUP) = 0
      MTRPLP = MEQU(MEQUP)
      MTEMP2 = MTRPL(MTRPLP+NOPS) - MAXSIZ
      IF(MTEMP2.LT.0 .OR. MTEMP2.GT.MAXSIZ) GO TO 2833
C..Store the variable number at 2000+MEQUP.
      INOUT(2000+MEQUP) = MTEMP2
 2833 CONTINUE
C--------
C Search for the FNT's.  Store in INOUT, first positions.
C--------
      KOUNT = 0
      DO 2836 MEQUP=1,MREQUP
      MTEMP1 = INOUT(2000+MEQUP)
      MTEMP2 = MVAR(MTEMP1)
C..Does the variable name start with FNT?
      IF(MTEMP2.NE.NAMEFT) GO TO 2836
      MTEMP3 = MVAR(MTEMP1+NVARS)
C..Does the variable name ends with CND?
      IF(MTEMP3.EQ.NAME) GO TO 2834
      MTEMP3 = MTEMP3 - NCN0
C..This is the cardinal.
      INOUT(MTEMP3) = MEQUP
      GO TO 2835
 2834 INOUT(1) = MEQUP
 2835 KOUNT = KOUNT + 1
      IF(KOUNT.EQ.NCARD) GO TO 2837
 2836 CONTINUE
C--------
C Search for variables using FNT's.  It should be a simple product.
C   Store in INOUT, +100 positions.
C--------
 2837 DO 2840 K=1,NCARD
      KOUNT = 0
      N = NCARD + 1 - K
      MTEMP1 = INOUT(N)
      NMVAR = INOUT(2000+MTEMP1)
C..This is the identifying number of the FNT's.
C..Cancel the reference at 2000+.
      INOUT(2000+MTEMP1) = 0
      DO 2839 I=1,MREQUP
C..Check the reference at 2000+.
      IF(INOUT(2000+I) .EQ. 0) GO TO 2839
      MTRPLP = MEQU(I)
      MTEMP2 = MTRPL(MTRPLP+NOP3)
      IF(MTEMP2.GT.MAXSIZ) GO TO 2839
C..Look at the left and right branches, only to the first node.
      MTEMP3 = MTRPL(MTEMP2+NOPS) - MAXSIZ
      IF(MTEMP3.EQ.NMVAR) GO TO 2838
      MTEMP3 = MTRPL(MTEMP2+NOP3) - MAXSIZ
      IF(MTEMP3.NE.NMVAR) GO TO 2839
 2838 KOUNT = KOUNT + 1
C..Found variable using FNT.  Store in INOUT, +100 position.
C..Cancel the reference at 2000+.
      INOUT(N+100*KOUNT) = I
      INOUT(2000+I) = 0
 2839 CONTINUE
      INOUT(N+1000) = KOUNT
 2840 CONTINUE
C--------
C Store the re-ordered equation pointers in MND.
C--------
      MEQTOP = 0
      DO 2842 K=1,NCARD
      N = NCARD + 1 - K
      MTEMP1 = INOUT(N)
      MEQTOP = MEQTOP + 1
      INOUT(2000+MEQTOP) = MEQU(MTEMP1)
      MEQU(MTEMP1) = 0
      KOUNT = INOUT(N+1000)
      DO 2841 I=1,KOUNT
      MTEMP1 = INOUT(N+100*I)
      MEQTOP = MEQTOP + 1
      INOUT(2000+MEQTOP) = MEQU(MTEMP1)
 2841 MEQU(MTEMP1) = 0
 2842 CONTINUE
      DO 2843 K=1,MREQUP
      IF(MEQU(K).EQ.0) GO TO 2843
      MEQTOP = MEQTOP + 1
      INOUT(2000+MEQTOP) = MEQU(K)
 2843 CONTINUE
C--------
      DO 2844 K=1,MREQUP
 2844 MEQU(K) = INOUT(2000+K)
C--------
C end of ORDDAE
C--------
      RETURN
      END
