C  File rclib3.for                     30-DEC-1993

      SUBROUTINE SUBFT(KONTRL,SHIFT,KTERM,BASEF,H,KEY,FNTOUT,IP,RP,WK)
C********
C  ATOMFT Subroutine-Library, version 3.11, completed (1/31/93).
C    Copyright (C) 1979-93, Y. F. Chang.
C********
      DIMENSION IP(20),RP(20),WK(1830),FNTOUT(1),BASEF(1),FACTOR(30)
      SAVE FACTOR
      DATA FACTOR/1.0,1.0,2.0,6.0,24.0,120.0,720.0,5.04E3,4.032E4,
     A 3.6288E5,3.6288E6,3.99168E7,4.790016E8,6.227021E9,8.717829E10,
     A 1.307674E12,2.092279E13,3.556874E14,6.402374E15,1.216451E17,
     A 2.432902E18,5.109094E19,1.124001E21,2.585202E22,6.204484E23,
     A 1.551121E25,4.032915E26,1.088887E28,3.048883E29,8.841762E30/
      LIST = IP(5)
      IF(KONTRL.EQ.2) GO TO 100
      WK(900+KTERM) = SHIFT
      IF(KEY.GT.2)GO TO 3220
      FNTOUT(KTERM) = WK(900+KTERM)
      RETURN
C------
C..This portion of this subroutine is for inverse functions.
C------
  100 WK(KTERM*30-29) = SHIFT*FACTOR(KTERM)
      IF(KTERM.EQ.1) GO TO 3200
      IF(KTERM.EQ.2) GO TO 3105
      KTOP = KTERM - 2
      DO 3102 N=1,KTOP
      M = KTERM - N
      MA = M + 1
      NA = N + 1
      SHIFT = 0.0
      DO 3101 KK=1,N
      NK = NA - KK
 3101 SHIFT = SHIFT + WK((MA-1)*30+NK)*WK(1801+KK)*KK
      IF(SHIFT .EQ. 0.0) GO TO 3102
      IF(ABS(SHIFT) .GT. RP(14) .OR. ABS(SHIFT) .LT. RP(13)) THEN
C..Give a warning message and stop.
         WRITE(LIST,13)
   13 FORMAT(/' SUBFT near over/underflow, try double-precision.')
         STOP
      ENDIF
 3102 WK((M-1)*30+NA) = SHIFT/N
      SHIFT = 0.0
      DO 3104 KK=1,KTOP
      NK = KTERM - KK
 3104 SHIFT = SHIFT + WK(1801+KK)*WK(30+NK)*KK
      WK(1800+KTERM) = - SHIFT/(WK(31)*(KTERM-1))
      SHIFT = WK(1800+KTERM)
      WK(KTERM) = SHIFT
      WK(900+KTERM) = SHIFT/H**(KTERM-1)
      GO TO 3210
 3105 WK(1802) = H/WK(31)
      WK(2) = WK(1802)
      WK(902) = WK(1802)/H
      GO TO 3210
 3200 WK(1) = SHIFT
      WK(901) = SHIFT
 3210 IF(KEY.GT.2) GO TO 3220
      FNTOUT(KTERM) = WK(KTERM)
      GO TO 9999
C------
C This is for functions of variables other than the independent variable.
C------
 3220 KTOP = KTERM - 1
      IF(KTOP.LT.1) GO TO 3303
      DO 3302 N=1,KTOP
      M = KTERM - N
      MA = M + 1
      NA = N + 1
      SHIFT = 0.0
      DO 3301 KK=1,N
      L = N + 2 - KK
 3301 SHIFT = SHIFT + WK(870+KK*30+MA)*BASEF(L)*(L-1)
 3302 WK(870+NA*30+M) = SHIFT*M/N
 3303 FNTOUT(KTERM) = WK(871+KTERM*30)
 9999 RETURN
C********
C end SUBFT
C********
      END
